Package: genefilter
Title: genefilter: methods for filtering genes from high-throughput
        experiments
Version: 1.94.0
Authors@R: c(
        person("Robert", "Gentleman", role = "aut"),
        person("Vincent J.", "Carey", role = "aut"),
        person("Wolfgang", "Huber", role = "aut"),
        person("Florian", "Hahne", role = "aut"),
        person("Emmanuel", "Taiwo", role = "ctb",
                comment = "'howtogenefinder' vignette translation from Sweave to RMarkdown / HTML."),
        person("Khadijah", "Amusat", role = "ctb",
                comment = "Converted genefilter vignette from Sweave to RMarkdown / HTML."),
        person("Bioconductor Package Maintainer", role = "cre",
                email = "maintainer@bioconductor.org"))
Description: Some basic functions for filtering genes.
Suggests: class, hgu95av2.db, tkWidgets, ALL, ROC, RColorBrewer,
        BiocStyle, knitr
Imports: MatrixGenerics (>= 1.11.1), AnnotationDbi, annotate, Biobase,
        graphics, methods, stats, survival, grDevices
License: Artistic-2.0
LazyLoad: yes
LazyData: yes
Collate: AllClasses.R AllGenerics.R all.R dist2.R eSetFilter.R fastT.R
        filter_volcano.R filtered_p.R genefinder.R half.range.mode.R
        kappa_p.R nsFilter.R rejection_plot.R rowROC-accessors.R
        rowSds.R rowpAUCs-methods.R rowttests-methods.R shorth.R zzz.R
biocViews: Microarray
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/genefilter
git_branch: RELEASE_3_23
git_last_commit: 68e3734
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 22:12:58 UTC; biocbuild
Author: Robert Gentleman [aut],
  Vincent J. Carey [aut],
  Wolfgang Huber [aut],
  Florian Hahne [aut],
  Emmanuel Taiwo [ctb] ('howtogenefinder' vignette translation from
    Sweave to RMarkdown / HTML.),
  Khadijah Amusat [ctb] (Converted genefilter vignette from Sweave to
    RMarkdown / HTML.),
  Bioconductor Package Maintainer [cre]
Maintainer: Bioconductor Package Maintainer <maintainer@bioconductor.org>

##RG introduces two new functions, varFilter that does what nsFilter
##was supposed to, but never did, and featureFilter that does the only
##useful stuff that nsFilter does
rowIQRs <- function(eSet) {
  numSamp <- ncol(eSet)
  lowQ <- rowQ(eSet, floor(0.25 * numSamp))
  upQ <- rowQ(eSet, ceiling(0.75 * numSamp))
  upQ - lowQ
}


##For NOW, we will need to check the schema from within nsFilter and
##featureFilter to decide what the internal ID is that needs to be used.
##LATER, when we haev annotation packages that will make this sort of access
##easier, it will make more sense to just access the central ID for those
##packages.

## It looks like I can take care of both nsFilter and featureFilter in this
## way by just altering what the helper function findLargest() does






varFilter <- function(eset, var.func=IQR, var.cutoff=0.5,filterByQuantile=TRUE
)
{
    if (deparse(substitute(var.func)) == "IQR") {
        vars <- rowIQRs(eset)
    } else {
        vars <- apply(exprs(eset), 1, var.func)
    }
    if (filterByQuantile) {
        if ( 0 < var.cutoff && var.cutoff < 1 ) {
            quant = quantile(vars, probs = var.cutoff)
            selected = !is.na(vars) & vars > quant
        } else stop("Cutoff Quantile has to be between 0 and 1.")
    } else {
        selected <- !is.na(vars) & vars > var.cutoff
    }
    eset <- eset[selected, ]
}


.getRequiredIDs <- function(eset, map){
  annChip <- annotation(eset)
  if(.isOrgSchema(annChip)){
    IDs <- featureNames(eset)
    names(IDs) <- featureNames(eset)
  }else{
    IDs <- mget(featureNames(eset), envir=getAnnMap(map, annChip), ifnotfound=NA)
  }
  IDs
}

featureFilter <- function(eset, require.entrez=TRUE,
                   require.GOBP=FALSE, require.GOCC=FALSE,
                   require.GOMF=FALSE, require.CytoBand=FALSE,
                   remove.dupEntrez=TRUE,
                   feature.exclude="^AFFX") {

    annChip <- annotation(eset)
    if (nchar(annChip) == 0) stop("'eset' must have a valid annotation slot")
    
    nfeat <- function(eset) length(featureNames(eset))
    requireID <- function(eset, map) {
        IDs <- .getRequiredIDs(eset, map)
        haveID <- names(IDs)[sapply(IDs, function(x) !is.na(x))]
        eset[haveID, ]
    }

    
    if (require.entrez) {
        map <- .findCentralMap(annChip)
        eset <- requireID(eset, map)
    }
    
    filterGO <- function(eset, ontology) {
        haveGo <- sapply(mget(featureNames(eset), getAnnMap("GO", annChip), ifnotfound=NA),
                         function(x) {
                             if (length(x) == 1 && is.na(x))
                                 FALSE
                             else {
                                 onts <- subListExtract(x, "Ontology", simplify=TRUE)
                                 ontology %in% onts
                             }
                         })
        eset[haveGo, ]
    }
    
    if (require.GOBP) 
        eset <- filterGO(eset, "BP")
    if (require.GOCC) 
        eset <- filterGO(eset, "CC")
    if (require.GOMF) 
        eset <- filterGO(eset, "MF")

    if (length(feature.exclude)) {
        fnms <- featureNames(eset)
        badIdx <- integer(0)
        for (pat in feature.exclude) {
            if (nchar(pat) == 0)
                next
            badIdx <- c(grep(pat, fnms), badIdx)
        }
        if (length(badIdx)) {
            badIdx <- unique(badIdx)
            eset <- eset[-badIdx, ]
        }
    }
    if (remove.dupEntrez ) {
     ## Reduce to unique probe <--> gene mapping here by keeping largest IQR
     ## We will want "unique genes" in the non-specific filtered gene
     ## set.
        uniqGenes <- findLargest(featureNames(eset), rowIQRs(eset),
                                 annotation(eset))
        eset <- eset[uniqGenes, ]
    }

    requireCytoBand <- function(eset) {
        MAPs <- mget(featureNames(eset), envir=getAnnMap("MAP", annChip), ifnotfound=NA)
        haveMAP <- names(MAPs)[sapply(MAPs, function(x) !is.na(x[1]))]
        eset[haveMAP, ]
    }

    if (require.CytoBand)
        eset <- requireCytoBand(eset)
    
    eset
}


setMethod("nsFilter", "ExpressionSet",
          function(eset,
                   require.entrez=TRUE,
                   require.GOBP=FALSE,
                   require.GOCC=FALSE,
                   require.GOMF=FALSE,
                   require.CytoBand=FALSE,
                   remove.dupEntrez=TRUE,
                   var.func=IQR, var.cutoff=0.5,
                   var.filter=TRUE,
                   filterByQuantile=TRUE,
                   feature.exclude="^AFFX", ...)
          {
              if (!is.function(var.func))
                stop("'var.func' must be a function")

              annChip <- annotation(eset)
              if (nchar(annChip) == 0)
                stop("'eset' must have a valid annotation slot")

              nfeat <- function(eset) length(featureNames(eset))
              filter.log <- new.env(parent=emptyenv())

              requireID <- function(eset, map) {
                IDs <- .getRequiredIDs(eset, map)
                  haveID <- names(IDs)[sapply(IDs, function(x) !is.na(x))]
                  logvar <- paste("numRemoved", map, sep=".")
                  assign(logvar, nfeat(eset) - length(haveID), envir=filter.log)
                  eset[haveID, ]
              }

              if (require.entrez) {
                  map <- .findCentralMap(annChip)
                  eset <- requireID(eset, map)
              }

              filterGO <- function(eset, ontology) {
                  haveGo <- sapply(mget(featureNames(eset), getAnnMap("GO", annChip), ifnotfound=NA),
                                   function(x) {
                                       if (length(x) == 1 && is.na(x))
                                         FALSE
                                       else {
                                           onts <- subListExtract(x, "Ontology", simplify=TRUE)
                                           ontology %in% onts
                                       }
                                   })
                  logvar <- paste("numNoGO", ontology, sep=".")
                  assign(logvar, sum(!haveGo), envir=filter.log)
                  eset[haveGo, ]
              }

              if (require.GOBP) {
                  eset <- filterGO(eset, "BP")
              }

              if (require.GOCC) {
                  eset <- filterGO(eset, "CC")
              }

              if (require.GOMF) {
                  eset <- filterGO(eset, "MF")
              }

              if (length(feature.exclude)) {
                  fnms <- featureNames(eset)
                  badIdx <- integer(0)
                  for (pat in feature.exclude) {
                      if (nchar(pat) == 0)
                        next
                      badIdx <- c(grep(pat, fnms), badIdx)
                  }
                  if (length(badIdx)) {
                      badIdx <- unique(badIdx)
                      eset <- eset[-badIdx, ]
                      logvar <- "feature.exclude"
                      assign(logvar, length(badIdx), filter.log)
                  }
              }


              if (remove.dupEntrez) {
                  ## Reduce to unique probe <--> gene mapping here by keeping largest IQR
                  ## We will want "unique genes" in the non-specific filtered gene
                  ## set.
                  if (deparse(substitute(var.func)) == "IQR") {
                      esetIqr <- rowIQRs(exprs(eset))
                  } else {
                      esetIqr <- apply(exprs(eset), 1, var.func)
                  }
                  numNsWithDups <- nfeat(eset)
                  uniqGenes <- findLargest(featureNames(eset), esetIqr,
                                           annotation(eset))
                  eset <- eset[uniqGenes, ]
                  logvar <- "numDupsRemoved"
                  assign(logvar, numNsWithDups - nfeat(eset), envir=filter.log)
              }


              if (var.filter) {
                  if (deparse(substitute(var.func)) == "IQR") {
                      esetIqr <- rowIQRs(exprs(eset))
                  } else {
                      esetIqr <- apply(exprs(eset), 1, var.func)
                  }
                  ##note this was not happening in the first
                  ##version - despite the documentation
                  if (filterByQuantile) {
                      if ( 0 < var.cutoff && var.cutoff < 1 ) {
                          var.cutoff = quantile(esetIqr, var.cutoff)
                      } else stop("Cutoff Quantile has to be between 0 and 1.")
                  }
                  selected <- esetIqr > var.cutoff
                  eset <- eset[selected, ]
                  logvar <- "numLowVar"
                  assign(logvar, sum(!selected), filter.log)
              }

              requireCytoBand <- function(eset) {
                  MAPs <- mget(featureNames(eset), envir=getAnnMap("MAP", annChip), ifnotfound=NA)
                  haveMAP <- names(MAPs)[sapply(MAPs, function(x) !is.na(x[1]))]
                  logvar <- paste("numRemoved", "MAP", sep=".")
                  assign(logvar, nfeat(eset) - length(haveMAP), envir=filter.log)
                  eset[haveMAP, ]
              }

              if (require.CytoBand)
                  eset <- requireCytoBand(eset)

              numSelected <- length(featureNames(eset))
              list(eset=eset, filter.log=as.list(filter.log))
          })

.onLoad <- function(lib, pkgname) {
    if(.Platform$OS.type == "windows" && interactive() && .Platform$GUI ==  "Rgui"){
      addVigs2WinMenu("genefilter")
   }
 }

.onUnload <- function( libpath ) {
  library.dynam.unload( "genefilter", libpath )
}

##--------------------------------------------------------------------------------------##
## This file contains methods definitions for rowttests, colttest, rowFtests, colFtests ##
##--------------------------------------------------------------------------------------##


##-----------------------------------------------------------------------
## The core function for row- and column-wise t-tests - it uses C code
##------------------------------------------------------------------------
rowcoltt =  function(x, fac, tstatOnly, which, na.rm) {
  if (!missing(tstatOnly) && (!is.logical(tstatOnly) || is.na(tstatOnly)))
      stop(sQuote("tstatOnly"), " must be TRUE or FALSE.")
  
  f = checkfac(fac)
  if ((f$nrgrp > 2) || (f$nrgrp <= 0))
    stop("Number of groups is ", f$nrgrp, ", but must be >0 and <=2 for 'rowttests'.")

  if (typeof(x) == "integer")
      x[] <- as.numeric(x)

  cc = .Call("rowcolttests", x, f$fac, f$nrgrp, which-1L, na.rm,
             PACKAGE="genefilter")
    
  res = data.frame(statistic = cc$statistic,
                   dm        = cc$dm,
                   row.names = dimnames(x)[[which]])

  if (!tstatOnly)
    res = cbind(res, p.value = 2*pt(abs(res$statistic), cc$df, lower.tail=FALSE))

  attr(res, "df") = cc$df    
  return(res)
}

##------------------------------------------------------------
## The core function for F-tests - it uses R matrix algebra 
##------------------------------------------------------------
rowcolFt =  function(x, fac, var.equal, which) {
  
  if(!(which %in% c(1L, 2L)))
    stop(sQuote("which"), " must be 1L or 2L.")
  
  if(which==2L)
    x = t(x)

  if (typeof(x) == "integer")
      x[] <- as.numeric(x)

  sqr = function(x) x*x
  
  stopifnot(length(fac)==ncol(x), is.factor(fac), is.matrix(x))
  x   <- x[,!is.na(fac), drop=FALSE]
  fac <- fac[!is.na(fac)]

  ## Number of levels (groups)
  k <- nlevels(fac)

  ## xm: a nrow(x) x nlevels(fac) matrix with the means of each factor
  ## level
  xm <- matrix(
     sapply(levels(fac), function(fl) rowMeans(x[,which(fac==fl), drop=FALSE])),
     nrow = nrow(x),
     ncol = nlevels(fac))

  ## x1: a matrix of group means, with as many rows as x, columns correspond to groups 
  x1 <- xm[,fac, drop=FALSE]

  ## degree of freedom 1
  dff    <- k - 1

  if(var.equal){
    ## x0: a matrix of same size as x with overall means
    x0 <- matrix(rowMeans(x), ncol=ncol(x), nrow=nrow(x))
  
    ## degree of freedom 2
    dfr    <- ncol(x) - dff - 1

    ## mean sum of squares
    mssf   <- rowSums(sqr(x1 - x0)) / dff
    mssr   <- rowSums(sqr( x - x1)) / dfr

    ## F statistic
    fstat  <- mssf/mssr

  } else{

    ## a nrow(x) x nlevels(fac) matrix with the group size  of each factor
    ## level
    ni <- t(matrix(tapply(fac,fac,length),ncol=nrow(x),nrow=k))

    ## wi: a nrow(x) x nlevels(fac) matrix with the variance * group size of each factor
    ## level
    sss <- sqr(x-x1)
    x5 <- matrix(
       sapply(levels(fac), function(fl) rowSums(sss[,which(fac==fl), drop=FALSE])),
       nrow = nrow(sss),
       ncol = nlevels(fac))          
    wi <- ni*(ni-1) /x5

    ## u : Sum of wi
    u  <- rowSums(wi)

    ## F statistic
    MR <- rowSums(sqr((1 - wi/u)) * 1/(ni-1))*1/(sqr(k)-1)
    fsno <- 1/dff * rowSums(sqr(xm - rowSums(wi*xm)/u) * wi)
    fsdeno <- 1+ 2* (k-2)*MR
    fstat <- fsno/fsdeno

    ## degree of freedom 2: Vector with length nrow(x)
    dfr <- 1/(3 * MR)
  
  }
  
  res = data.frame(statistic = fstat,
                   p.value   = pf(fstat, dff, dfr, lower.tail=FALSE),
                   row.names = rownames(x))

  attr(res, "df") = c(dff=dff, dfr=dfr)
  return(res)
}

## ==========================================================================
## rowttests and colttests methods for 'matrix'
## ==========================================================================
setMethod("rowttests", signature(x="matrix", fac="factor"),
          function(x, fac, tstatOnly=FALSE, na.rm = FALSE)
          rowcoltt(x, fac, tstatOnly, 1L, na.rm))

setMethod("rowttests", signature(x="matrix", fac="missing"),
          function(x, fac, tstatOnly=FALSE, na.rm = FALSE)
          rowcoltt(x, factor(integer(ncol(x))), tstatOnly, 1L, na.rm))

setMethod("colttests", signature(x="matrix", fac="factor"),
          function(x, fac, tstatOnly=FALSE, na.rm = FALSE)
          rowcoltt(x, fac, tstatOnly, 2L, na.rm))

setMethod("colttests", signature(x="matrix", fac="missing"),
          function(x, fac, tstatOnly=FALSE, na.rm = FALSE)
          rowcoltt(x, factor(integer(ncol(x))), tstatOnly, 2L, na.rm))


## ==========================================================================
## rowFtests and colFtests methods for 'matrix'
## ==========================================================================
setMethod("rowFtests", signature(x="matrix", fac="factor"),
          function(x, fac, var.equal=TRUE)
          rowcolFt(x, fac, var.equal, 1L))

setMethod("colFtests", signature(x="matrix", fac="factor"),
          function(x, fac, var.equal=TRUE)
          rowcolFt(x, fac, var.equal, 2L))


## ===========================================================================
## Methods for 'ExpressionSet': only for rowttests and rowFtests
## -==========================================================================
setMethod("rowttests", signature(x="ExpressionSet", fac="factor"),
  function(x, fac, tstatOnly=FALSE, na.rm = FALSE)
    rowcoltt(exprs(x), fac, tstatOnly=tstatOnly, 1L, na.rm))

setMethod("rowttests", signature(x="ExpressionSet", fac="missing"),
  function(x, fac, tstatOnly=FALSE, na.rm = FALSE) {
    x = exprs(x)
    fac = integer(ncol(x))
    rowcoltt(x, fac, tstatOnly, 1L, na.rm)
  })

setMethod("rowttests", signature(x="ExpressionSet", fac="character"),
  function(x, fac, tstatOnly=FALSE, na.rm = FALSE) {
    if (length(fac) != 1)
      stop("fac must be length 1 character or a factor")
    fac = factor(pData(x)[[fac]])
    rowcoltt(exprs(x), fac, tstatOnly, 1L, na.rm)
  })

setMethod("rowFtests", signature(x="ExpressionSet", fac="factor"),
  function(x, fac, var.equal=TRUE)
    rowcolFt(exprs(x), fac, var.equal, 1L))

setMethod("rowFtests", signature(x="ExpressionSet", fac="character"),
 function(x, fac, var.equal=TRUE) {
   fac = factor(as.integer(factor(pData(x)[[fac]]))-1L)
   rowcolFt(exprs(x), fac, var.equal, 1L)
 })



## ------------------------------------------------------------
## convert fac from factor or numeric to integer and then
## make sure it is an integer 
## ------------------------------------------------------------
checkfac = function(fac) {

  if(is.numeric(fac)) {
    nrgrp = as.integer(max(fac, na.rm=TRUE)+1)
    fac   = as.integer(fac)
  }
  ## this must precede the factor test
  if(is.character(fac))
    fac = factor(fac)

  if (is.factor(fac)) {
    nrgrp = nlevels(fac)
    fac   = as.integer(as.integer(fac)-1)
  } 
  if(!is.integer(fac))
    stop("'fac' must be factor, character, numeric, or integer.")
  
  if(any(fac<0, na.rm=TRUE))
    stop("'fac' must not be negative.")
    
  return(list(fac=fac, nrgrp=nrgrp))
}

filter_volcano <- function(
                           d, p, S,
                           n1, n2,
                           alpha, S_cutoff,
                           cex = .5, pch = 19,
                           xlab = expression( paste( log[2], " fold change" ) ),
                           ylab = expression( paste( "-", log[10], " p" ) ),
                           cols = c( "grey80", "grey50", "black" ),
                           ltys = c( 1, 3 ),
                           use_legend = TRUE,
                           ...
                           )
{

  f <- S < S_cutoff
  
  col <- rep( cols[1], length(d) )
  col[ !f & p >= alpha ] <- cols[2]
  col[ !f & p < alpha ] <- cols[3]  

  plot(
       d,
       -log10( p ),
       cex = cex,
       pch = pch,
       xlab = xlab,
       ylab = ylab,
       col = col,
       ...
       )

  k_grid <- seq( 0, max( -log10( p ) ), length = 100 )
  p_grid <- 10^( -k_grid )
  
  lines( kappa_p( p_grid, n1, n2 ) * S_cutoff, k_grid, lty = ltys[1] )
  lines( -1 * kappa_p( p_grid, n1, n2 ) * S_cutoff, k_grid, lty = ltys[1] )

  segments(
           c( par("usr")[1], kappa_p( alpha, n1, n2 ) * S_cutoff ),
           -log10( alpha ),
           c( -kappa_p( alpha, n1, n2 ) * S_cutoff, par("usr")[2] ),
           -log10( alpha ),
           lty = ltys[2]
           )

  if ( use_legend )
    legend(
           "topleft",
           c( "Filtered", "Insig.", "Sig." ),
           pch = pch,
           col = cols,
           inset = .025,
           bg = "white"
           )

}

rowVars = function(x, ...) {
  sqr     = function(x)  x*x
  n       = rowSums(!is.na(x))
  n[n<=1] = NA
  return(rowSums(sqr(x-rowMeans(x, ...)), ...)/(n-1))
}

rowSds = function(x, ...)
  sqrt(rowVars(x, ...))

## ==========================================================================
## core rowpAUCs method for objects of class matrix
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("rowpAUCs", signature(x="matrix", fac="factor"),
          function(x, fac, p=0.1, flip=TRUE, caseNames=c("1", "2")){  
            ##check argument 'p'
            if(!is.numeric(p) || length(p)>1)
              stop("'p' must be numeric of length 1")
            ## check argument 'fac'
            f <- checkfac(fac)
            if(f$nrgrp != 2 || length(f$fac) != ncol(x) ||
               length(unique(f$fac)) !=2 )
                stop("'fac' must be factor with 2 levels and length 'ncol(x)'")
            ## check argument 'flip'
            if(length(flip)!=1 || !(is.logical(flip)))
                stop("'flip' must be logical scalar")
            flip <- as.integer(flip)
            ## compute cutpoints
            cutpts <- matrix((0:ncol(x))+0.5, ncol=ncol(x)+1, 
                             nrow=nrow(x), byrow=TRUE,
                             dimnames=list(rownames(x), NULL))
            
            ## rank data
            xr <- t(apply(x, 1, rank))
            mode(xr) <- "numeric"
            ## call C function and return object of class 'rowROC'
            res <- .Call("ROCpAUC", xr, cutpts, as.integer(f$fac), p,
                         PACKAGE="genefilter", flip)
            sens <- res$sens
            spec <- res$spec
            rownames(sens) <- rownames(spec) <- rownames(x)
            pAUC <- res$pAUC
            AUC <- res$AUC
            names(AUC) <- names(pAUC) <- rownames(x)
            object <- new("rowROC", data=x, sens=sens,
                          spec=spec, pAUC=pAUC, AUC=AUC,
                          factor=factor(f$fac), p=p, ranks=xr,
                          caseNames=as.character(caseNames),
                          cutpoints=cutpts)
            return(object)
          })
## ==========================================================================


## ==========================================================================
## rowpAUCs method with signature x=matrix, fac=numeric
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("rowpAUCs", signature(x="matrix", fac="numeric"),
          function(x, fac, p=0.1, flip=TRUE, caseNames=c("1", "2")){
            cutpts <- matrix((0:ncol(x))+0.5, ncol=ncol(x)+1, 
                             nrow=nrow(x), byrow=TRUE)
            rowpAUCs(x=x, fac=factor(fac), p=p, flip=flip,
                   caseNames=caseNames) 
          })
## ==========================================================================


## ==========================================================================
## rowpAUCs method with signature x=ExpressionSet
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
setMethod("rowpAUCs", signature(x="ExpressionSet"),        
          function(x, fac, p=0.1, flip=TRUE, caseNames=c("1", "2")){
            rowpAUCs(x=exprs(x), fac=fac, p=p, flip=flip,
                     caseNames=caseNames) 
          })
## ==========================================================================


## ==========================================================================
## rowpAUCs method with signature x=ExpressionSet fac=character
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  
setMethod("rowpAUCs", signature(x="ExpressionSet", fac="character"),        
          function(x, fac, p=0.1, flip=TRUE, caseNames=c("1", "2")){
            if (length(fac) == 1){
                if(!fac %in% colnames(pData(x)))
                    stop("fac must be length 1 character indicating a ",
                         "covariate in the phenoData slot of the expressionSet")
                cn <- as.character(levels(pData(x)[[fac]]))
                fac = factor(as.integer(factor(pData(x)[[fac]]))-1)
                rowpAUCs(x=exprs(x), fac=fac, p=p, flip=flip, caseNames=cn)
            }else{
                rowpAUCs(x=x, fac=as.factor(fac), p=p, flip=flip,
                         caseNames=caseNames)
            }
          })
## ==========================================================================

##FIXME: this could replace the code further below at some point,
## but only when it has the var.equal option
##--------------------------------------------------
## fastT
##--------------------------------------------------
#fastT = function(x, ig1, ig2, var.equal=TRUE) {
#  fac      = rep(NA, ncol(x))
#  fac[ig1] = 0
#  fac[ig2] = 1
#  .Call("rowcolttests", x, as.integer(fac), as.integer(2),
#               as.integer(0), PACKAGE="genefilter")
#}



fastT = function(x, ig1, ig2, var.equal=TRUE) {
    ng1=length(ig1)
    ng2 = length(ig2)
    if( ncol(x) != ng1+ng2)
        stop("wrong sets of columns")

    outd = x[,c(ig1, ig2),drop=FALSE]
    nr = nrow(outd)
    z = rep(0, nr)
    dm = rep(0, nr)
    Z = .Fortran("fastt", d=as.single(outd), as.integer(nr),
           as.integer(ng1+ng2), as.integer(ng1), z = as.single(z),
         dm = as.single(dm), var.equal=as.integer(var.equal),
         ratio = as.integer(as.integer(0)), PACKAGE="genefilter")
    return(list(z = Z$z, dm=Z$dm, var.equal=Z$var.equal))
}

# genefinder.R
#
# genefinder functions.


genescale <- function (m, axis=2, method=c("Z", "R"), na.rm=TRUE) {
    ##scale by the range
    RscaleVector <- function(v, na.rm) {
        mm <- range(v, na.rm=na.rm)
        (v - mm[1]) / (mm[2] - mm[1])
    }
    ##scale using Zscore
    ZscaleVector <- function(v, na.rm)
        (v - mean(v, na.rm=na.rm))/sd(v, na.rm=na.rm)
#
# scales a matrix using the scaleVector function.
#
    which <- match.arg(method)
    method <- switch(which,
                     Z = ZscaleVector,
                     R = RscaleVector)
    if( is.matrix(m) || is.data.frame(m) ) {
        rval <- apply (m, axis, method, na.rm=na.rm)
        if( axis==1 ) return(t(rval))
        return(rval)
    }
    else
	method(m, na.rm=na.rm)
}


setMethod("genefinder", c("ExpressionSet", "vector", "ANY", "ANY", "ANY",
          "ANY"),
          function(X, ilist, numResults, scale, weights,
                   method) {
              gN <- featureNames(X)
              if (is.character(ilist))
                  ilist <- match(ilist,gN)
              ans <- genefinder(exprs(X), ilist, numResults, scale, weights,
                        method=method)
              names(ans) <- gN[ilist]
              ans
      })

setMethod("genefinder", c("matrix", "vector", "ANY", "ANY", "ANY", "ANY"),
         function (X, ilist, numResults, scale, weights,
                        method) {
    X <- as.matrix(X)
    METHOD <- c("euclidean", "maximum", "manhattan",
                        "canberra", "correlation", "binary")
    method<-pmatch(method, METHOD)
    if (is.na(method))
        stop ("The distance method is invalid.")

    SCALE <- c("none", "range", "zscore")
    scale <- SCALE[pmatch(scale, SCALE)]

    # perform scaling if requested.
    #
    X <- switch(scale,
                none=X,
                range=genescale(X),
                zscore=scale(X),
                stop("The scaling method is invalid")
                )
    N <- nrow(X)
    C <- ncol(X)

    if( !is.vector(ilist) )
        stop("the genes to be compared to must be in a vector")

    ninterest <- length(ilist);

    if( is.character(ilist) ) {
        iRows <- match(ilist, row.names(X))
        names(iRows) <- ilist
    }
    else if ( is.numeric(ilist) ) {
        iRows <- ilist
        names(iRows) <- row.names(X)[ilist]
    }
    else
        stop("invalid genes selected")

    if( any(is.na(iRows)) )
        stop("invalid genes selected")

    if (missing(weights))
        weights <- rep(1,C)
    else if (length(weights) != C)
        stop("Supplied weights do not match number of columns")

    ## Do a sanity check on the requested genes in ilist -> if the
    ## gene exceeds the # of rows in the matrix, can not be processed.
    if (max(iRows) > N)
        stop("Requested genes exceed the dimensions of the supplied matrix.")


    Genes <- array(as.integer(NA), dim=c(ninterest, numResults))
    Dists <- array(as.integer(NA), dim=c(ninterest, numResults))
    extCall <- .C("gf_distance",
                  X = as.double(X),
                  nr= as.integer(N),
                  nc= ncol(X),
                  g = as.integer(Genes),
                  d = as.double(Dists),
                  iRow  = as.integer(iRows),
                  nInterest = as.integer(ninterest),
                  nResults = as.integer(numResults),
                  method= as.integer(method),
                  weights = as.double(weights),
                  NAOK=TRUE, PACKAGE="genefilter")

    Genes <- extCall$g+1
    Dists <- extCall$d
    Which <- vector()

    ## Get the number of genes/dists per selection.  There should
    ## always be a number of total genes such that they are a multiple
    ## of ninterest
    numPerList <- length(Genes) / ninterest

    Which <- rep(iRows, rep(numPerList, ninterest))

    byGene <- split(Genes, Which)
    names(byGene) <- rep("indices", length(byGene))
    byDists <- split(Dists, Which)
    names(byDists) <- rep("dists", length(byDists))
    ## Need a better way to stuff these together
    retList <- list()
    for (i in 1:ninterest) {
        retList[[i]] <- list(indices=byGene[[i]], dists=byDists[[i]])
    }

    return(retList)
})

## Classes for package genefilter

## ==========================================================================
## class rowROC: objects model result of call to function rowpAUCs,
##               pAUC or AUC
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setClass("rowROC",
         representation(data = "matrix",
                        ranks = "matrix",
                        sens = "matrix",
                        spec = "matrix",
                        pAUC = "numeric",
                        AUC = "numeric",
                        factor = "factor",
                        cutpoints = "matrix",
                        caseNames = "character",
                        p = "numeric"),
         validity=function(object){
           if(any(dim(object@sens) != dim(object@spec)))
             return("\n'sens' and 'spec' must be matrices with equal dimensions")
           if(length(object@pAUC) != nrow(object@sens))
             return("\n'pAUC' must be numeric of length equal to nrow(sens)")
           if(length(object@factor)!=ncol(object@data) ||
              length(levels(object@factor))!=2)
             return("'factor' must be factor object with two levels and length = ncol(data)")
           if(length(object@pAUC) != length(object@AUC))
             return("'pAUC' and 'AUC' must be numeric vectors of equal length")
           if(nrow(object@cutpoints) != length(object@pAUC))
             return("'cutpoints' must be matrix with nrow=length(pAUC)")
           if(length(object@caseNames)!=2)
             return("'caseNames' must be character vector of length 2")
           return(TRUE)
         }
         )
## ==========================================================================

shorth <- function(x, na.rm=FALSE, tie.action="mean", tie.limit=0.05) {
  stopifnot(is.numeric(x))
  if (na.rm) {
    x <- x[is.finite(x)]
  } else {
    if(any(!is.finite(x)))
      stop("'x' contains NA or NaN, and 'na.rm' is FALSE.")
  }
    
  if(length(x)==0L) {
    
    NA_real_
      
    } else {
      
      sx    <- sort(x)
      width <- round(0.5*length(x))
      diffs <- sx[(width+1):length(x)] - sx[seq_len(length(x)-width)]
      
      ## cannot use which.min since we want all minimising points not just one:
      q  <- which(diffs==min(diffs))
      
      if(length(q)>1) {
        ## deal with ties:
        maxq = max(q)
        minq = min(q)
        ## take the action specified in "tie.action"
        q <- switch(tie.action,
                    mean = {
                      if (maxq-minq <= tie.limit * length(x)) {
                        mean(q)
                      } else {
                        stop(paste("Encountered tie(s), and the difference between minimal and maximal value is larger than 'length(x)*tie.limit'.",
                                   "This could mean that the distribution does not have a single well-defined mode.",
                                   paste("q=", minq, "...", maxq, ",  values=", signif(sx[minq],4), "...", signif(sx[minq+width],4), sep=""), sep="\n"))
                      }},
                    max  = maxq, ## largest midpoint (maxq)
                    min  = minq, ## smallest midpoint (minq)
                    stop(sprintf("Invalid value '%s' for argument 'tie.action'", tie.action))
                    )
      } ## if
      
      mean(sx[q:(q+width-1)])
      
    } ## if
  
}

dist2 = function (x,
                  fun = function(a, b) mean(abs(a - b), na.rm = TRUE),
                  diagonal = 0) {

  if (!(is.numeric(diagonal) && (length(diagonal) == 1)))
    stop("'diagonal' must be a numeric scalar.")

  if (missing(fun)) {
    res = apply(x, 2, function(w) colMeans(abs(x-w), na.rm=TRUE))
  } else {
    res = matrix(diagonal, ncol = ncol(x), nrow = ncol(x))
    if (ncol(x) >= 2) {
      for (j in 2:ncol(x))
        for (i in 1:(j - 1))
          res[i, j] = res[j, i] = fun(x[, i], x[, j])
    } # if
  } # else

  colnames(res) = rownames(res) = colnames(x)
  return(res)
}

#copyright 2001 R. Gentleman

#FILTER FUNCTIONS -- some trivial changes

kOverA <- function(k, A=100, na.rm = TRUE) {
  function(x) {
      if(na.rm)
	x <- x[!is.na(x)]
      sum( x > A ) >= k
  }
}

maxA <- function(A=75, na.rm=TRUE) {
    function(x) {max(x, na.rm=na.rm) >= A }
}


pOverA <-  function(p=0.05, A=100, na.rm = TRUE) {
  function(x) {
      if(na.rm)
	 x<-x[!is.na(x)]
      sum( x > A )/length(x) >= p
  }
}


cv <- function(a=1, b=Inf, na.rm=TRUE) {
    function(x) {
        	sdx <- sd(x, na.rm=na.rm)
        if(is.na(sdx) || sdx == 0 ) return(FALSE)
	val <- sdx/abs(mean(x, na.rm=na.rm))
        if(val < a ) return(FALSE)
        if(val > b ) return(FALSE)
        return(TRUE)
            }
}

Anova <- function(cov, p=0.05, na.rm=TRUE)
{
    function(x) {
        if( na.rm ) {
            drop <- is.na(x)
            x <- x[!drop]
            cov <- cov[!drop]
        }
        m1 <- lm(x~cov)
        m2 <- lm(x~1)
        av <- anova(m2,m1)
        fstat <- av[["Pr(>F)"]][2]
        if( fstat < p )
            return(TRUE)
        return(FALSE)
    }
}

coxfilter <- function(surt, cens, p) {
   autoload("coxph", "survival")
   function(x) {
       srvd <- try(coxph(Surv(surt,cens)~x))
       if( inherits(srvd, "try-error") )
           return(FALSE)
       ltest <- -2*(srvd$loglik[1] - srvd$loglik[2])
       pv <- 1 - pchisq(ltest, 1)
       if( pv < p )
           return(TRUE)
       return(FALSE)
   }
}

ttest <- function(m, p=0.05, na.rm=TRUE) {
    if( length(m) == 1)
        function(x) {
            n <- length(x)
            if( m>n ) stop("m is larger than the number of samples")
            sub1 <- x[1:m]
            sub2 <- x[(m+1):n]
            if(na.rm) {
                drop <- is.na(x)
                sub1 <- sub1[!drop[1:m]]
                sub2 <- sub2[!drop[(m+1):n]]
            }
            t.test(sub1, sub2 )$p.value < p
        }
    else
        function(x) {
            if(na.rm) {
                drop <- is.na(x) | is.na(m)
                x<- x[!drop]
                m<- m[!drop]
            }
            t.test(x~m)$p.value < p
        }
  }


##a filter based on gaps

gapFilter <- function(Gap, IQR, Prop, na.rm=TRUE, neg.rm=TRUE) {
  function(x) {
     if(na.rm) x <- x[!is.na(x)]
     if(neg.rm) x <- x[x>0]
     lenx <- length(x)
     if( lenx < 4 || lenx < Prop+1 )
       return(FALSE)
     srtd <- sort(x)
     lq <- lenx*.25
     uq <- lenx*.75
     if( (srtd[uq] - srtd[lq]) > IQR )
        return(TRUE)
     if(Prop < 1)
        bot <- lenx*Prop
     else
        bot <- Prop
     top <- lenx - bot
     lag1 <- srtd[2:lenx]-srtd[1:(lenx-1)]
     if( max(lag1[bot:top]) > Gap )
       return(TRUE)
    return(FALSE)
  }
}


# Apply type functions


genefilter <- function(expr, flist)
    {
     if(is(expr, "ExpressionSet"))
       expr <- exprs(expr)
     apply(expr, 1, flist)
}

filterfun <- function(...) {
     flist <- list(...)
 #let the user supply a list
     if( length(flist) == 1 && is.list(flist[[1]]) )
         flist <- flist[[1]]
     f <- function( x ) {
         for( fun in flist ) {
             fval <- fun(x)
             if( is.na(fval) || ! fval )
                 return(FALSE)
         }
             return(TRUE)
     }
     class(f) <- "filterfun"
     return(f)
 }

.findDBMeta <- function(chip, item) {
    connfunc <- getAnnMap("_dbconn", chip)
    dbmeta(connfunc(), item)
}

.isOrgSchema <- function(chip){
    schema <- .findDBMeta(chip, "DBSCHEMA")
    length(grep("CHIP", schema)) == 0
}

.findCentralMap<- function(chip){
    centID <- .findDBMeta(chip, "CENTRALID")
    if(!.isOrgSchema(chip) && centID == "TAIR") {
        "ACCNUM" ## a peculiar exception with historical causes
    } else {
        centID   ## should cover EVERYTHING else
    }
}


findLargest = function(gN, testStat, data="hgu133plus2") {
    lls = if(.isOrgSchema(data)){
        gN ##not a chip package so try the IDs presented.
    } else {
        map = .findCentralMap(data)
        unlist(mget(gN, getAnnMap(map, data)), use.names=FALSE)
    }
    if(length(testStat) != length(gN) )
        stop("testStat and gN must be the same length")
    if( is.null(names(testStat)) )
        names(testStat) = gN
    tSsp = split.default(testStat, lls)
    sapply(tSsp, function(x) names(which.max(x)))
}

half.range.mode <- function( data, B, B.sample, beta = .5, diag = FALSE ) {

  if ( length( data ) == 0 ) return( NA_real_ )

  if (missing( B ) ) {

    # Just one run on the full set...
    
    if ( is.unsorted( data ) ) data <- sort( data )
    
    .C(
       "half_range_mode",
       data = as.double( data ),
       n = as.integer( length( data ) ),
       beta = as.double( beta ),
       diag = as.integer( diag ),
       M = double(1),
       PACKAGE = "genefilter"
       )$M

  }

  else {

    # Bootstrapped

    if ( missing( B.sample ) )
      B.sample <- length( data )

    M <- sapply(seq_len(B),
                function (x) {
                  d <- sort( sample( data, B.sample, replace = TRUE ) )
                  .C(
                     "half_range_mode",
                     data = as.double( d ),
                     n = as.integer( B.sample ),
                     beta = as.double( beta ),
                     diag = as.integer( diag ),
                     M = double(1),
                     PACKAGE = "genefilter"
                     )$M
                }
                )

    mean( M )
    
  }

}

## Generic functions for package genefilter

setGeneric("rowFtests", function(x, fac, var.equal=TRUE)
           standardGeneric("rowFtests"))
setGeneric("colFtests", function(x, fac, var.equal=TRUE)
           standardGeneric("colFtests"))
setGeneric("rowttests", function(x, fac, tstatOnly=FALSE, na.rm = FALSE)
           standardGeneric("rowttests"))
setGeneric("colttests", function(x, fac, tstatOnly=FALSE, na.rm = FALSE)
           standardGeneric("colttests"))


setGeneric("genefinder", function(X, ilist, numResults=25, scale="none",
    weights, method="euclidean" )
    standardGeneric("genefinder"))


setGeneric("pAUC", function(object, p, flip=TRUE) standardGeneric("pAUC"))

setGeneric("AUC", function(object) standardGeneric("AUC"))

setGeneric("sens", function(object) standardGeneric("sens"))

setGeneric("spec", function(object) standardGeneric("spec"))

setGeneric("area", function(object, total=FALSE) standardGeneric("area"))

setGeneric("rowpAUCs", function(x, fac, p=0.1, flip=TRUE, caseNames=c("1", "2"))
           standardGeneric("rowpAUCs"))

setGeneric("nsFilter", signature="eset",
           function(eset,
                    require.entrez=TRUE,
                    require.GOBP=FALSE,
                    require.GOCC=FALSE,
                    require.GOMF=FALSE,
                    require.CytoBand=FALSE,
                    remove.dupEntrez=TRUE,
                    var.func=IQR, var.cutoff=0.5, var.filter=TRUE,
                    filterByQuantile=TRUE,
                    feature.exclude="^AFFX", ...)
           standardGeneric("nsFilter"))

c By R Gray, March 19, 2000, DFCI
c Copyright (C) 2000 Robert Gray
c Distributed under the GNU public license
c
c t-statistics
c first ng1 columns of d assumed to be group 1, other ng-ng1 assumed to be
c group2.  Note: single precision stats
c
c  Modified by R. Gentleman, 2004, just extracted the ttest stats and 
c  computed a ratio on demand - or fold-change

      subroutine fastt(d,n,ng,ng1,z,dm,eqv,ratio)
      real d(n,ng),z(n),dm(n)
      integer n,ng,ng1,ng2,eqv,ratio
c  initialize
      ng2=ng-ng1
      do 61 i=1,n
         call tst2GM(d(i,1),ng1,ng2,n,z(i),dm(i), eqv, ratio)
 61   continue
      return
      end

      subroutine tst2GM(d,ng1,ng2,n,tst,dm,eqv, ratio)
c columns 1 to ng1 in group 1, ng1+1 to ng1+ng2 in group 2
      real d(n,ng1+ng2),tst,dm
      double precision dm1,dm2,dss1,dss2
      integer ng1,ng2,n,i,eqv, ratio
      dm1=0
      dm2=0
      dss1=0
      dss2=0
      do 10 i=1,ng1
         dm1=dm1+d(1,i)
 10   continue
      dm1=dm1/ng1
      do 11 i=1,ng1
         dss1=dss1+(d(1,i)-dm1)**2
 11   continue
      do 12 i=1,ng2
         dm2=dm2+d(1,ng1+i)
 12   continue
      dm2=dm2/ng2
      do 13 i=1,ng2
         dss2=dss2+(d(1,ng1+i)-dm2)**2
 13   continue
      if( ratio.eq.0) then
         dm=dm1-dm2
      endif
      if( ratio.eq.1) then
         dm=dm1/dm2
      endif 
      if (dss1.eq.0.and.dss2.eq.0) then
         tst=0
         return
      endif
c intermediate calculations in dp, so stats with many ties give same sp result
c regardless of order of calculations
      if( eqv .eq. 1 ) then
         tst=(dm1-dm2)/sqrt((1.d0/ng1+1.d0/ng2)*(dss1+dss2)/(ng1+ng2-2))
         return
      endif
      tst=(dm1-dm2)/sqrt(dss1/((ng1-1)*ng1)+dss2/((ng2-1)*ng2))
      end

rejection_plot <- function(p,
                           col, lty = 1, lwd = 1,
                           xlab = "p cutoff", ylab = "number of rejections",
                           xlim = c( 0, 1 ), ylim,
                           legend = names(p),
                           at = c( "all", "sample" ),
                           n_at = 100,
                           probability = FALSE,
                           ...
                           )
{

  if ( is.matrix( p ) ) {
    legend <- colnames( p )
    p <- lapply( 1:ncol(p), function(i) p[,i] )
  }

  if ( missing( col ) )
    col <- rainbow( length( p ), v = .7 )

  col <- rep( col, length.out = length( p ) )
  lty <- rep( lty, length.out = length( p ) )
  lwd <- rep( lwd, length.out = length( p ) )
    
  if ( missing( ylim ) )
    ylim <- c( 0, ifelse( probability, 1, max( sapply( p, length ) ) ) )

  at <- match.arg( at )
  
  steps <- lapply(
                  p,
                  function(x) {
                    x <- na.omit(x)
                    stepfun(
                            sort( x ),
                            ( 0:length(x) ) / ifelse( probability, length(x), 1 )
                            )
                  }
                  )

  plot(
       0,
       type = "n",
       xaxs = "i", yaxs = "i",
       xlim = xlim, ylim = ylim,
       xlab = xlab, ylab = ylab,
       ...
       )

  if ( at == "all" ) {
    for ( i in 1:length( steps ) )
      lines(
            steps[[i]],
            xlim = xlim,
            col = col[i], lty = lty[i], lwd = lwd[i],
            do.points = FALSE
            )
  }
  
  else {
    x <- seq( xlim[1], xlim[2], length = n_at )
    for ( i in 1:length( steps ) )
      lines(
            x, steps[[i]](x),
            col = col[i], lty = lty[i], lwd = lwd[i]
            )
  }

  if ( !is.null( legend ) )
    legend(
           "topleft", 
           legend,
           col = col, lty = lty, lwd = lwd,           
           inset = .05
           )
  
  invisible( steps )

}

filtered_p <- function( filter, test, theta, data, method = "none" ) {

  if ( is.function( filter ) )
    U1 <- filter( data )
  else
    U1 <- filter

  cutoffs <- quantile( U1, theta )

  result <- matrix( NA_real_, length( U1 ), length( cutoffs ) )
  colnames( result ) <- names( cutoffs )
  
  for ( i in 1:length( cutoffs ) ) {    
    use <- U1 >= cutoffs[i]
    if( any( use ) ) {
      if( is.function( test ) )
        U2 <- test( data[use,] )
      else
        U2 <- test[use]
      result[use,i] <- p.adjust( U2, method )
    }
  }

  return( result )
  
}




filtered_R <- function( alpha, filter, test, theta, data, method = "none" ) {

  p <- filtered_p( filter, test, theta, data, method )

  return( apply( p, 2, function(x) sum( x < alpha, na.rm = TRUE ) ) )

}

# This widget allows users to pick filters in the order they are going
# to be used to filer genes and set the parameters for
# each filter.
#
# Copyright 2003, J. Zhang. All rights reserved.
#

eSetFilter <- function(eSet){
    #
    # 2020-12-31 Wolfgang Huber: marking this as deprecated due to dubious coding style
    # (leading to many notes in R CMD check), lack of maintenance, apparently minuscule
    # update (e.g. I did not find a single mention of this function with
    # https://support.bioconductor.org/post/search/?query=esetfilter today) and
    # availability of better alternatives.
    #
    .Deprecated(new = "iSEE", old = "eSetFilter")
    
    require("tkWidgets", character.only = TRUE) ||
    stop("eSetFilter requires the tkWidgets ",
         "package. Please have it installed")

    descList <- getFuncDesc()

    buildGUI <- function(){
        END <<- FALSE

        selectedNames <- NULL
        filterWithArgs <- list()

        setFilter <- function(){
            currentFilter <- as.character(tkget(filters,
                                             (tkcurselection(filters))))
            args <- setESetArgs(currentFilter)
            if(!is.null(args)){
                expression <- paste(currentFilter, "(",
                    paste(names(args), args, sep = "=", collapse = ","),
                    ")", sep = "")
                filterWithArgs[[currentFilter]] <<- eval(parse(text =
                                                               expression))
                selectedNames <<- unique(c(selectedNames, currentFilter))
                writeList(pickedF, selectedNames)
                tkconfigure(selectBut, state = "disabled")
            }
        }
        cancel <- function(){
            tkdestroy(base)
        }
        finish <- function(){
            END <<- TRUE
            tkdestroy(base)
        }
        viewFilter <- function(){
            currentFilter <- as.character(tkget(filters,
                                             (tkcurselection(filters))))
            tkconfigure(description, state = "normal")
            writeText(description, descList[[currentFilter]])
            tkconfigure(description, state = "disabled")
            tkconfigure(selectBut, state = "normal")
        }
        pickedSel <- function(){
            tkconfigure(remBut, state = "normal")
        }
        remove <- function(){
             filter <- as.character(tkget(pickedF,
                                             (tkcurselection(pickedF))))
             selectedNames <<- setdiff(selectedNames, filter)
             writeList(pickedF, selectedNames)
             tkconfigure(remBut, state = "disabled")

        }

        base <- tktoplevel()
        tktitle(base) <- "BioC Filter Master"
        # Pack the top frame with a brief description
        introText <- tktext(base, width = 30, height = 4, wrap = "word")
        text <- paste("Bioconductor's gene filtering functons are",
                      "listed below. Select one from the list to view the",
                      "description and formal arguments for each filter.",
                      "A filter can be selected to the set of filters",
                      "for filtering genes using the select button.")
        writeText(introText, text)
        tkconfigure(introText, state = "disabled")
        tkpack(introText, expand = FALSE, fill  = "both", padx = 5)
        # Pack a frame with a list box for selected filters and
        # buttons manipulate the selected filters
        infoFrame <- tkframe(base)
        filterFrame <- tkframe(infoFrame)
        tkpack(tklabel(filterFrame, text = "Filters"), expand = FALSE,
               fill = "x")
        listFrame <- tkframe(filterFrame)
        filters <- makeViewer(listFrame, vHeight = 10, vWidth = 12,
                                vScroll = TRUE, hScroll = TRUE,
                                what = "list")
        tkbind(filters, "<B1-ButtonRelease>", viewFilter)
        tkbind(filters, "<Double-Button-1>", setFilter)
        writeList(filters, getFilterNames())
        tkpack(listFrame, expand = TRUE, fill = "both")
        selectBut <- tkbutton(filterFrame, text = "Select",
                              command = setFilter, state = "disabled")
        tkpack(selectBut, expand = FALSE, fill = "x")
        tkpack(filterFrame, side = "left", expand = FALSE, fill = "both")
        descFrame <- tkframe(infoFrame)
        tkpack(tklabel(descFrame, text = "Description"), expand = FALSE,
               fill = "x")
        dListFrame <- tkframe(descFrame)
        description <- makeViewer(dListFrame, vHeight = 10, vWidth = 30,
                                vScroll = TRUE, hScroll = TRUE,
                                what = "text")
        tkconfigure(description, wrap = "word", state = "disabled")
        tkpack(dListFrame, expand = TRUE, fill = "both")
        tkpack(descFrame, side = "left", expand = TRUE, fill = "both")
        selFrame <- tkframe(infoFrame)
        tkpack(tklabel(selFrame, text = "Selected"),
               expand = FALSE, fill = "x")
        selFFrame <- tkframe(selFrame)
        pickedF <- makeViewer(selFFrame, vHeight = 10, vWidth = 12,
                                vScroll = TRUE, hScroll = TRUE,
                                what = "list")
        tkbind(pickedF, "<B1-ButtonRelease>", pickedSel)
        tkbind(pickedF, "<Double-Button-1>", remove)
        tkpack(selFFrame, expand = TRUE, fill = "both")
        remBut <- tkbutton(selFrame, text = "Remove", command = remove,
                           state = "disabled")
        tkpack(remBut, expand = FALSE, fill = "x")
        tkpack(selFrame, expand = FALSE, fill = "both")
        tkpack(infoFrame, expand = TRUE, fill = "both", padx = 5)
        # Pack the bottom frame with cancel and finish buttons
        endFrame <- tkframe(base)
        cancelBut <- tkbutton(endFrame, width = 8, text = "Cancel",
                           command = cancel)
        tkpack(cancelBut, side = "left", expand = TRUE, fill = "x",
               padx = 10)
        finishBut <- tkbutton(endFrame, width = 8, text = "finish",
                           command = finish)
        tkpack(finishBut, side = "left", expand = TRUE, fill = "x",
               padx = 10)
        tkpack(endFrame, expand = FALSE, fill = "x", pady = 5)

        showESet(eSet)
        tkwait.window(base)

        if(END){
            tempList <- list()
            for(i in  selectedNames){
                tempList[[i]] <- filterWithArgs[[i]]
            }
            return(tempList)
        }else{
            return(NULL)
        }
    }

    filters <- buildGUI()
    if(!is.null(filters)){
        filters <- filterfun(unlist(filters))
        return(genefilter(exprs(eSet), filters))
    }else{
        return(NULL)
    }
}

getFilterNames <- function(){
    .Deprecated()
    return(sort(c("Anova", "coxfilter", "cv", "gapFilter", "kOverA",
    "maxA", "pOverA", "ttest")))
}

getFuncDesc <- function(lib = "genefilter", funcs = getFilterNames()){
    .Deprecated()
    descList <- list()

    lines <- getRdAsText(lib)
    for(i in funcs){
        rd <- lines[grep(paste("\\\\name\\{", i, "\\}", sep = ""), lines)]
        desc <- parseDesc(rd)
        args <- parseArgs(rd)
        if(length(args) > 0){
            temp <- "\n\nArguments:"
            for(j in names(args)){
                temp <- c(temp, paste(j, "-", args[[j]]))
            }
            args <- paste(temp, sep = "", collapse = "\n")
        }
        descList[[i]] <- paste(desc, args, sep = "", collapse = "")
    }
    return(descList)
}

getRdAsText <- function(lib){
    .Deprecated()
    fileName <- gzfile(file.path(.path.package(lib), "man",
                          paste(lib, ".Rd.gz", sep = "")), open = "r")
    lines <- readLines(fileName)

    lines <- paste(lines, sep = "", collapse = " ")
    lines <- unlist(strsplit(lines, "\\\\eof"))
    return(lines)
}

parseDesc <- function(text){
    .Deprecated()
    descRExp <- ".*\\\\description\\{(.*)\\}.*\\\\usage\\{.*"
    text <- gsub(descRExp, "\\1", text)
    text <- gsub("(\\\\[a-zA-Z]*\\{|\\})", "", text)
    return(text)
}

parseArgs <- function(text){
    .Deprecated()
    argsList <- list()
    text <- gsub(".*\\\\arguments\\{(.*)\\}.*\\\\details\\{.*", "\\1", text)
    text <- gsub(".*\\\\arguments\\{(.*)\\}.*\\\\value\\{.*", "\\1", text)
    text <- unlist(strsplit(text, "\\\\item\\{"))
    text <- gsub("(\\\\[a-zA-Z]*\\{|\\})", "", text)
    for(i in text){
        i <- unlist(strsplit(i, "\\{"))
        if(length(i) > 1){
            argsList[[i[1]]] <- i[2]
        }
    }
    return(argsList)
}

showESet <- function(eSet){
    .Deprecated()
    end <- function(){
        tkdestroy(base)
    }
    if(!is(eSet, "eSet")){
        stop()
    }
    colNRow <- dim(exprs(eSet))
    vl <- varLabels(eSet)
    text <- c(paste("Genes: ", colNRow[1]),
              paste("Samples: ", colNRow[2], sep = ""),
              "Variable labels:",
              paste(names(vl), ": ", vl[1:length(vl)], sep = ""))

    base <- tktoplevel()
    tktitle(base) <- "BioC ExpressionSet viewer"
    dataDescFrame <- tkframe(base)
    data <- makeViewer(dataDescFrame, vHeight = 10, vWidth = 25,
                       vScroll = TRUE, hScroll = TRUE,
                       what = "list")
    writeList(data, text)
    tkpack(dataDescFrame, expand = TRUE, fill = "both")
    endBut <- tkbutton(base, text = "Finish", command = end)
    tkpack(endBut, expand = FALSE, fill = "x", pady = 5)
}

setESetArgs <- function(filter){
    .Deprecated()
    on.exit(tkdestroy(base))

    cancel <- function(){
        tkdestroy(base)
    }
    end <- function(){
        END <<- TRUE
        tkdestroy(base)
    }
    END <- FALSE
    argsVar <- list()
    desc <- list()
    entries <- list()
    ftFun <- list()

    args <- getRdAsText("genefilter")
    args <- args[grep(paste("\\\\name\\{", filter, "\\}", sep = ""), args)]
    args <- parseArgs(args)
    argValues <- formals(filter)

    base <- tktoplevel()
    tktitle(base) <- "BioC Filter Argument input"

    tkgrid(tklabel(base, text = "Arguments"),
           tklabel(base, text = "Descriptions"),
           tklabel(base, text = "Values"))
    for(i in names(args)){
        argsVar[[i]] <- tclVar(as.character(argValues[[i]]))
        tempFrame <- tkframe(base)
        desc[[i]] <- makeViewer(tempFrame, vHeight = 3, vWidth = 55,
                                vScroll = FALSE, hScroll = FALSE,
                                what = "text")
        writeText(desc[[i]], args[[i]])
        tkconfigure(desc[[i]], wrap = "word", state = "disabled")
        entries[[i]] <- tkentry(base, textvariable = argsVar[[i]],
                                    width = 10)
        tkgrid(tklabel(base, text = i), tempFrame, entries[[i]])
        if(any(as.character(argValues[[i]]) == c("FALSE", "TRUE"))){
             ftFun[[i]] <- function(){}
             body <- list(as.name("{"),
                          substitute(eval(if(tclvalue(argsVar[[j]]) ==
                                                      "TRUE"){
                              writeList(entries[[j]], "FALSE")}else{
                                  writeList(entries[[j]], "TRUE")}),
                                     list(j = i)))
             body(ftFun[[i]]) <- as.call(body)
             tkbind(entries[[i]],"<B1-ButtonRelease>", ftFun[[i]])
        }
        tkgrid.configure(tempFrame, sticky = "eswn")
    }

    butFrame <- tkframe(base)
    canBut <- tkbutton(butFrame, text = "cancel", width = 8,
                       command = cancel)
    endBut <- tkbutton(butFrame, text = "Finish", width = 8,
                       comman = end)
    tkpack(canBut, side = "left", expand = FALSE, fill = "x")
    tkpack(endBut, side = "left", expand = FALSE, fill = "x")
    tkgrid(butFrame, columnspan = 3)

    tkwait.window(base)
    if(END){
        for(i in names(argValues)){
            argValues[[i]] <- tkWidgets:::formatArg(tclvalue(argsVar[[i]]))
        }
        return(argValues)
    }else{
        return(NULL)
    }
}

isESet <- function(eSet){
    .Deprecated()
    if(missing(eSet) ||
       (!is(eSet, "ExpressionSet"))) {
        tkmessageBox(title = "Input Error",
                     message = paste("filterMaster has to take",
                     "an object of class ExpressionSet"),
                     icon = "warning",
                     type = "ok")
        return(FALSE)
    }else{
        return(TRUE)
    }
}

## ----closeg, message = FALSE--------------------------------------------------
library("Biobase") 
library("genefilter")
data(sample.ExpressionSet)
varLabels(sample.ExpressionSet)
table(sample.ExpressionSet$sex)
table(sample.ExpressionSet$type)

## ----message=FALSE------------------------------------------------------------
f1 <- kOverA(5, 200)
ffun <- filterfun(f1)
wh1 <- genefilter(exprs(sample.ExpressionSet), ffun)
sum(wh1)

## -----------------------------------------------------------------------------
f2 <- ttest(sample.ExpressionSet$type, p=0.1)
wh2 <- genefilter(exprs(sample.ExpressionSet), filterfun(f2))
sum(wh2)

## ----gene-indexing------------------------------------------------------------
ffun_combined <- filterfun(f1, f2)
wh3 <- genefilter(exprs(sample.ExpressionSet), ffun_combined)
sum(wh3)

## ----knnCV--------------------------------------------------------------------
knnCV <- function(x, selectfun, cov, Agg, pselect = 0.01, scale=FALSE) {
   nc <- ncol(x)
   outvals <- rep(NA, nc)
   for(i in seq_len(nc)) {
      v1 <- x[,i]
      expr <- x[,-i]
      glist <- selectfun(expr, cov[-i], p=pselect)
      expr <- expr[glist,]
      if( scale ) {
        expr <- scale(expr)
        v1 <- as.vector(scale(v1[glist]))
      }
      else
         v1 <- v1[glist]
      out <- paste("iter ",i, " num genes= ", sum(glist), sep="")
      print(out)
      Aggregate(row.names(expr), Agg)
      if( length(v1) == 1)
         outvals[i] <- knn(expr, v1, cov[-i], k=5)
      else
          outvals[i] <- knn(t(expr), v1, cov[-i], k=5)
    }
    return(outvals)
}

## ----aggregate1---------------------------------------------------------------
gfun <- function(expr, cov, p=0.05) {
   f2 <- ttest(cov, p=p)
   ffun <- filterfun(f2)
   which <- genefilter(expr, ffun)
  }

## ----aggregate2, results="hide"-----------------------------------------------
library("class")
##scale the genes
##genescale is a slightly more flexible "scale"
##work on a subset -- for speed only
geneData <- genescale(exprs(sample.ExpressionSet)[1:75,], 1) 
Agg <- new("aggregator") 
testcase <- knnCV(geneData, gfun, sample.ExpressionSet$type, 
       Agg,pselect=0.05)  

## ----aggregate3---------------------------------------------------------------
sort(sapply(aggenv(Agg), c), decreasing=TRUE)

## ----echo=FALSE---------------------------------------------------------------
sessionInfo()

---
title: "Using the genefilter function to filter genes from a microarray dataset"
author:
- name: "Khadijah Amusat"
  affiliation: "Vignette translation from Sweave to R Markdown / HTML"
date: "`r format(Sys.time(), '%B %d , %Y')`"
output:
    BiocStyle::html_document:
    number_sections: true
    toc: true
    toc_depth: 4
package: genefilter
vignette: >
  %\VignetteIndexEntry{Using the genefilter function to filter genes from a microarray}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
---

# Introduction

The `r Biocpkg("genefilter")` package can be used to filter (select) genes from
a microarray dataset according to a variety of different filtering mechanisms.
Here, we will consider the example dataset in the `sample.ExpressionSet` example
from the `r Biocpkg("Biobase")` package. This experiment has 26 samples, and
there are 500 genes and 3 covariates. The covariates are named `sex`, `type` and
`score`. The first two have two levels and the last one is continuous.

```{r closeg, message = FALSE}
library("Biobase") 
library("genefilter")
data(sample.ExpressionSet)
varLabels(sample.ExpressionSet)
table(sample.ExpressionSet$sex)
table(sample.ExpressionSet$type)
```

One dichotomy that can be of interest for subsequent analyses is whether the
filter is *specific* or *non-specific*. Here, specific means that we are
filtering with reference to sample metadata, for example, `type`. For example,
if we want to select genes that are differentially expressed in the two groups
defined by `type`, that is a specific filter. If on the other hand we want to
select genes that are expressed in more than 5 samples, that is an example of a
non--specific filter.

First, let us see how to perform a non--specific filter. Suppose we want to
select genes that have an expression measure above 200 in at least 5 samples. To
do that we use the function `kOverA`.

There are three steps that must be performed.

1.  Create function(s) implementing the filtering criteria.

2.  Assemble it (them) into a (combined) filtering function.

3.  Apply the filtering function to the expression matrix.

```{r message=FALSE}
f1 <- kOverA(5, 200)
ffun <- filterfun(f1)
wh1 <- genefilter(exprs(sample.ExpressionSet), ffun)
sum(wh1)
```

Here `f1` is a function that implies our "expression measure above 200 in at
least 5 samples" criterion, the function `ffun` is the filtering function (which
in this case consists of only one criterion), and we apply it using `r
Biocpkg("genefilter")`. There were `r sum(wh1)` genes that satisfied the
criterion and passed the filter. As an example for a specific filter, let us
select genes that are differentially expressed in the groups defined by `type`.

```{r}
f2 <- ttest(sample.ExpressionSet$type, p=0.1)
wh2 <- genefilter(exprs(sample.ExpressionSet), filterfun(f2))
sum(wh2)
```

Here, `ttest` is a function from the `r Biocpkg("genefilter")` package which
provides a suitable wrapper around `t.test` from package `r Rpackage("stats")`.
Now we see that there are `r sum(wh2)` genes that satisfy the selection
criterion. Suppose that we want to combine the two filters. We want those genes
for which at least 5 have an expression measure over 200 *and* which also are
differentially expressed between the groups defined by `type`

```{r gene-indexing}
ffun_combined <- filterfun(f1, f2)
wh3 <- genefilter(exprs(sample.ExpressionSet), ffun_combined)
sum(wh3)
```

Now we see that there are only `r sum(wh3)` genes that satisfy both conditions.

## Selecting genes that appear useful for prediction

The function `knnCV` defined below performs $k$--nearest neighbour
classification using leave--one--out cross--validation. At the same time it
aggregates the genes that were selected. The function returns the predicted
classifications as its returned value. However, there is an additional side
effect. The number of times that each gene was used (provided it was at least
one) are recorded and stored in the environment of the aggregator `Agg`. These
can subsequently be retrieved and used for other purposes.

```{r knnCV}
knnCV <- function(x, selectfun, cov, Agg, pselect = 0.01, scale=FALSE) {
   nc <- ncol(x)
   outvals <- rep(NA, nc)
   for(i in seq_len(nc)) {
      v1 <- x[,i]
      expr <- x[,-i]
      glist <- selectfun(expr, cov[-i], p=pselect)
      expr <- expr[glist,]
      if( scale ) {
        expr <- scale(expr)
        v1 <- as.vector(scale(v1[glist]))
      }
      else
         v1 <- v1[glist]
      out <- paste("iter ",i, " num genes= ", sum(glist), sep="")
      print(out)
      Aggregate(row.names(expr), Agg)
      if( length(v1) == 1)
         outvals[i] <- knn(expr, v1, cov[-i], k=5)
      else
          outvals[i] <- knn(t(expr), v1, cov[-i], k=5)
    }
    return(outvals)
}
```

```{r aggregate1}
gfun <- function(expr, cov, p=0.05) {
   f2 <- ttest(cov, p=p)
   ffun <- filterfun(f2)
   which <- genefilter(expr, ffun)
  }
```

Next we show how to use this function on the dataset `geneData`

```{r aggregate2, results="hide"}
library("class")
##scale the genes
##genescale is a slightly more flexible "scale"
##work on a subset -- for speed only
geneData <- genescale(exprs(sample.ExpressionSet)[1:75,], 1) 
Agg <- new("aggregator") 
testcase <- knnCV(geneData, gfun, sample.ExpressionSet$type, 
       Agg,pselect=0.05)  
```

```{r aggregate3}
sort(sapply(aggenv(Agg), c), decreasing=TRUE)
```

The environment `Agg` contains, for each gene, the number of times it was selected in the cross-validation.

# Session Information

The version number of R and packages loaded for generating the vignette were:

```{r echo=FALSE}
sessionInfo()
```

%\VignetteIndexEntry{03 - Additional plots for: Independent filtering increases power for detecting differentially expressed genes, Bourgon et al., PNAS (2010)}
%\VignettePackage{genefilter}
%\VignetteEngine{knitr::knitr}

% To compile this document
% library('knitr'); rm(list=ls()); knit('independent_filtering_plots.Rnw')

\documentclass[10pt]{article}

<<knitr, echo=FALSE, results="hide">>=
library("knitr")
opts_chunk$set(tidy=FALSE,dev="png",fig.show="hide",
               fig.width=4,fig.height=4.5,dpi=240,
               message=FALSE,error=FALSE,warning=FALSE)
@ 

<<style, eval=TRUE, echo=FALSE, results="asis">>=
BiocStyle:::latex()
@

\usepackage{xstring}
\newcommand{\thetitle}{Additional plots for: Independent filtering increases power for detecting differentially expressed genes, Bourgon et al., PNAS (2010)}

\title{\thetitle}
\author{Richard Bourgon and Wolfgang Huber}

\begin{document}

<<setup, echo=FALSE>>=
options( width = 80 )
@ 

% Make title
\maketitle
\tableofcontents
\vspace{.25in}


%%%%%%%% Main text

\section{Introduction}

This vignette illustrates use of some functions in the
\emph{genefilter} package that provide useful diagnostics 
for independent filtering~\cite{BourgonIndependentFiltering}:

\begin{itemize}
  \item \texttt{kappa\_p} and \texttt{kappa\_t}
  \item \texttt{filtered\_p} and \texttt{filtered\_R}
  \item \texttt{filter\_volcano}
  \item \texttt{rejection\_plot}
\end{itemize}

\section{Data preparation}

Load the ALL data set and the \emph{genefilter} package:

<<libraries>>=
library("genefilter")
library("ALL")
data("ALL")
@

Reduce to just two conditions, then take a small subset of arrays from these,
with 3 arrays per condition:

<<sample_data, cache=TRUE>>=
bcell <- grep("^B", as.character(ALL$BT))
moltyp <- which(as.character(ALL$mol.biol) %in% 
                c("NEG", "BCR/ABL"))
ALL_bcrneg <- ALL[, intersect(bcell, moltyp)]
ALL_bcrneg$mol.biol <- factor(ALL_bcrneg$mol.biol)
n1 <- n2 <- 3
set.seed(1969)
use <- unlist(tapply(1:ncol(ALL_bcrneg), 
                     ALL_bcrneg$mol.biol, sample, n1))
subsample <- ALL_bcrneg[,use]
@

We now use functions from \emph{genefilter} to compute overall standard devation
filter statistics as well as standard two-sample $t$ and releated statistics.

<<stats, cache=TRUE>>=
S <- rowSds( exprs( subsample ) )
temp <- rowttests( subsample, subsample$mol.biol )
d <- temp$dm
p <- temp$p.value
t <- temp$statistic
@ 


\section{Filtering volcano plot}

Filtering on overall standard deviation and then using a standard $t$-statistic
induces a lower bound of fold change, albeit one which varies somewhat with the
significance of the $t$-statistic. The \texttt{filter\_volcano} function allows
you to visualize this effect.

<<filter_volcano, include=FALSE>>=
S_cutoff <- quantile(S, .50)
filter_volcano(d, p, S, n1, n2, alpha=.01, S_cutoff)
@ 
The output is shown in the left panel of Fig.~\ref{fig:volcano}.

\begin{figure}[tb]
\begin{center}
\includegraphics[width=0.49\textwidth]{figure/filter_volcano-1}
\includegraphics[width=0.49\textwidth]{figure/kappa-1}
\caption{Left panel: plot produced by the \texttt{filter\_volcano} function.
Right panel: graph of the \texttt{kappa\_t} function.}
\label{fig:volcano}
\end{center}
\end{figure}

The \texttt{kappa\_p} and \texttt{kappa\_t} functions, used to make the volcano
plot, compute the fold change bound multiplier as a function of either a
$t$-test $p$-value or the $t$-statistic itself. The actual induced bound on the
fold change is $\kappa$ times the filter's cutoff on the overall standard
deviation. Note that fold change bounds for values of $|T|$ which are close to 0
are not of practical interest because we will not reject the null hypothesis
with test statistics in this range.

<<kappa, include=FALSE>>=
t <- seq(0, 5, length=100)
plot(t, kappa_t(t, n1, n2) * S_cutoff, 
     xlab="|T|", ylab="Fold change bound", type="l")
@
The plot is shown in the right panel of Fig.~\ref{fig:volcano}.



\section{Rejection count plots}

\subsection{Across $p$-value cutoffs}

The \texttt{filtered\_p} function permits easy simultaneous calculation of
unadjusted or adjusted $p$-values over a range of filtering thresholds
($\theta$). Here, we return to the full ``BCR/ABL'' versus ``NEG'' data set, and
compute adjusted $p$-values using the method of Benjamini and Hochberg, for a
range of different filter stringencies.

\begin{figure}[tb]
\begin{center}
\includegraphics[width=0.49\textwidth]{figure/rejection_plot-1}
\includegraphics[width=0.49\textwidth]{figure/filtered_R_plot-1}
\caption{Left panel: plot produced by the \texttt{rejection\_plot} function.
Right panel: graph of \texttt{theta}.}
\label{fig:rej}
\end{center}
\end{figure}


<<table>>=
table(ALL_bcrneg$mol.biol)
@

<<filtered_p>>=
S2 <- rowVars(exprs(ALL_bcrneg))
p2 <- rowttests(ALL_bcrneg, "mol.biol")$p.value
theta <- seq(0, .5, .1)
p_bh <- filtered_p(S2, p2, theta, method="BH")
@

<<p_bh>>=
head(p_bh)
@ 

The \texttt{rejection\_plot} function takes sets of $p$-values corresponding to
different filtering choices --- in the columns of a matrix or in a list --- and
shows how rejection count ($R$) relates to the choice of cutoff for the
$p$-values. For these data, over a reasonable range of FDR cutoffs, increased
filtering corresponds to increased rejections.

<<rejection_plot>>=
rejection_plot(p_bh, at="sample",
               xlim=c(0,.3), ylim=c(0,1000),
               main="Benjamini & Hochberg adjustment")
@
The plot is shown in the left panel of Fig.~\ref{fig:rej}.




\subsection{Across filtering fractions}

If we select a fixed cutoff for the adjusted $p$-values, we can also look more
closely at the relationship between the fraction of null hypotheses filtered and
the total number of discoveries. The \texttt{filtered\_R} function wraps
\texttt{filtered\_p} and just returns rejection counts. It requires a $p$-value
cutoff. 

<<filtered_R>>=
theta <- seq(0, .80, .01)
R_BH <- filtered_R(alpha=.10, S2, p2, theta, method="BH")
@

<<R_BH>>=
head(R_BH)
@

Because overfiltering (or use of a filter which is inappropriate for the
application domain) discards both false and true null hypotheses, very large
values of $\theta$ reduce power in this example:

<<filtered_R_plot>>=
plot(theta, R_BH, type="l",
     xlab=expression(theta), ylab="Rejections",
     main="BH cutoff = 0.1")
@
The plot is shown in the right panel of Fig.~\ref{fig:rej}.



%%%%%%%% Session info

\section*{Session information}

<<sessionInfo, results='asis', echo=FALSE>>=
sessionInfo() |> toLatex()
@


\begin{thebibliography}{10}
\bibitem{BourgonIndependentFiltering}
Richard Bourgon, Robert Gentleman and Wolfgang Huber.
\newblock Independent filtering increases power for detecting differentially
expressed genes.
\end{thebibliography}



\end{document}

---
title: "How to find genes whose expression profile is similar to that of
specified genes"
author:
- name: "Emmanuel Taiwo"
  affiliation: "Vignette translation from Sweave to R Markdown / HTML" 
date: "`r format(Sys.time(), '%B %d, %Y')`" 
vignette: > 
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{How to find genes whose expression profile is similar to 
  that of specified genes} 
  %\VignettePackage{genefilter} 
  %\VignetteEncoding{UTF-8}
output: 
  BiocStyle::html_document: 
    number_sections: yes 
    toc: yes 
    toc_depth: 4
---

# Introduction 

In some cases you have certain genes of interest and you would like to find
other genes that are close to the genes of interest. This can be done using the
`genefinder` function.

You need to specify either the index position of the genes you want (which row
of the expression array the gene is in) or the name (consistent with the
`featureNames` of the ExpressionSet).

A vector of names can be specified and matches for all will be computed. The
number of matches and the distance measure used can all be specified. The
examples will be carried out using the artificial data set, `sample.ExpressionSet`.

Two other options for `genefinder` are `scale` and `method`. The `scale` option
controls the scaling of the rows (this is often desirable), while the `method`
option controls the distance measure used between genes. The possible values and
their meanings are listed at the end of this document.

```{r closeg, message = FALSE}
library("Biobase")
library("genefilter")
data(sample.ExpressionSet)
igenes <- c(300,333,355,419) ##the interesting genes
closeg <- genefinder(sample.ExpressionSet, igenes, 10, method="euc", scale="none")
names(closeg)
```

The Affymetrix identifiers (since these were originally Affymetrix data) are
`31539_r_at`, `31572_at`, `31594_at` and `31658_at`. We can find the nearest
genes (by index) for any of these by simply accessing the relevant component of
`closeg`.

```{r gene-indexing}
closeg$"31539_r_at"
Nms1 <- featureNames(sample.ExpressionSet)[closeg$"31539_r_at"$indices]
Nms1
```

You could then take these names (from `Nms1`) and the `r Biocpkg("annotate")`
package and explore them further. See the various HOWTO's in annotate to see how
to further explore your data. Examples include finding and searching all PubMed
abstracts associated with these data. Finding and downloading associated
sequence information. The data can also be visualized using the 
`r Biocpkg("geneplotter")` package (again there are a number of HOWTO documents there).

# Parameter Settings 

The scale parameter can take the following values:

**none** No scaling is done.

**range** Scaling is done by $(x_{i} − x_{(1)})/(x_{(n)} − x_{(1)})$.

**zscore** Scaling is done by $(x_{i} − \bar{x})/s_{x}$. Where s~x~ is the standard deviation.

The `method` parameter can take the following values:

**euclidean** Euclidean distance is used.

**maximum** Maximum distance between any two elements of x and y (supremum norm).

**manhattan** Absolute distance between the two vectors (1 norm).

**canberra** The $\sum(|x_{i} − y_{i}|/|x_{i} + y_{i}|)$. Terms with zero numerator 
and denominator are omitted from the sum and treated as if the values were missing.

**binary** (aka asymmetric binary): The vectors are regarded as binary bits, so 
non-zero elements are on and zero elements are off. The distance is the 
proportion of bits in which only one is on amongst those in which at least one is on.

# Session Information 

The version number of R and packages loaded for generating
the vignette were:

```{r, echo=FALSE}
sessionInfo()
```

\name{tdata}
\alias{tdata}
\non_function{}
\title{A small test dataset of Affymetrix Expression data. }
\usage{data(tdata)}
\description{
The \code{tdata} data frame has 500 rows and 26 columns.
The columns correspond to samples while the rows correspond to genes.
The row names are Affymetrix accession numbers.
}
\format{
  This data frame contains 26 columns.
}

\source{
 An unknown data set.
}

\examples{
data(tdata)
}
\keyword{datasets}

\name{coxfilter}
\alias{coxfilter}

\title{A filter function for univariate Cox regression. }
\description{
  A function that performs Cox regression with bindings for \code{surt},
  \code{cens}, and \code{p} is returned. This function filters genes
  according to the attained p-value from a Cox regression using
  \code{surt} as the survival times, and \code{cens} as the censoring
  indicator. It requires \code{survival}.
}
\usage{
coxfilter(surt, cens, p)
}
\arguments{
  \item{surt}{Survival times.}
  \item{cens}{Censoring indicator. }
  \item{p}{The p-value to use in filtering. }
}

\value{
  Calls to the \code{\link[survival]{coxph}} function in the \code{survival}
    library are used to fit a Cox model. The filter function returns
    \code{TRUE} if the p-value in the fit is less than \code{p}.
}

\author{R. Gentleman }
\seealso{\code{\link{Anova}}}

\examples{
   set.seed(-5)
   sfun <- coxfilter(rexp(10), ifelse(runif(10) < .7, 1, 0), .05)
   ffun <- filterfun(sfun)
   dat <- matrix(rnorm(1000), ncol=10)
   out <- genefilter(dat, ffun)
}
\keyword{manip}

\name{kOverA}
\alias{kOverA}
\title{A filter function for k elements larger than A. }
\description{
  \code{kOverA} returns a filter function with bindings for \code{k} and
  \code{A}. This function evaluates to \code{TRUE} if at least \code{k}
  of the arguments elements are larger than \code{A}.
}
\usage{
kOverA(k, A=100, na.rm=TRUE)
}
\arguments{
  \item{A}{The value you want to exceed. }
  \item{k}{The number of elements that have to exceed A.}
  \item{na.rm}{If set to \code{TRUE} any \code{NA}'s will be removed. }
}

\value{
 A function with bindings for \code{A} and \code{k}.
}

\author{R. Gentleman}

\seealso{\code{\link{pOverA}}}

\examples{
   fg <- kOverA(5, 100)
   fg(90:100)
   fg(98:110)
}
\keyword{manip}

\name{rowROC-class}
\docType{class}
\alias{rowROC}
\alias{rowROC-class}
\alias{pAUC}
\alias{AUC}
\alias{sens}
\alias{spec}
\alias{area}
\alias{pAUC,rowROC,numeric-method}
\alias{plot,rowROC,missing-method}
\alias{AUC,rowROC-method}
\alias{spec,rowROC-method}
\alias{sens,rowROC-method}
\alias{area,rowROC-method}
\alias{show,rowROC-method}
\alias{[,rowROC,ANY,ANY,ANY-method}


\title{Class "rowROC"}
\description{A class to model ROC curves and corresponding area under
  the curve as produced by rowpAUCs.}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("rowROC", ...)}.
}
\section{Slots}{
	 \describe{
    \item{\code{data}:}{Object of class \code{"matrix"} The input data.}
    \item{\code{ranks}:}{Object of class \code{"matrix"} The ranked
      input data. }
    \item{\code{sens}:}{Object of class \code{"matrix"} Matrix of
      senitivity values for each gene at each cutpoint. }
    \item{\code{spec}:}{Object of class \code{"matrix"} Matrix of
      specificity values for each gene at each cutpoint.}
    \item{\code{pAUC}:}{Object of class \code{"numeric"} The partial
      area under the curve (integrated from 0 to \code{p}. }
    \item{\code{AUC}:}{Object of class \code{"numeric"} The total area
      under the curve. }
    \item{\code{factor}:}{Object of class \code{"factor"} The factor
      used for classification.}
    \item{\code{cutpoints}:}{Object of class \code{"matrix"} The values
      of the cutpoints at which specificity ans sensitivity was
calculated. (Note: the data is ranked prior to computation
      of ROC curves, the cutpoints map to the ranked data.}
    \item{\code{caseNames}:}{Object of class \code{"character"} The
      names of the two classification cases.}
    \item{\code{p}:}{Object of class \code{"numeric"} The limit to which
\code{pAUC} is integrated. }
  }
}
\section{Methods}{
  \describe{
    \item{show \code{signature(object="rowROC")}}{Print nice info
      about the object.}
     \item{[ \code{signature(x="rowROC", j="missing")}}{Subset the
       object according to rows/genes.}
     \item{plot \code{signature(x="rowROC", y="missing")}}{Plot the ROC
       curve of the first row of the object along with the \code{pAUC}.
       To plot the curve for a specific row/gene subsetting should be done
       first (i.e. \code{plot(rowROC[1])}.}
    \item{pAUC \code{signature(object="rowROC", p="numeric", flip="logical")}}{Integrate
      area under the curve from \code{0} to \code{p}. This method
      returns a new \code{rowROC} object.}
    \item{AUC \code{signature(object="rowROC")}}{Integrate
      total area under the curve. This method returns a new
      \code{rowROC} object.}
    \item{sens \code{signature(object="rowROC")}}{Accessor method for
      sensitivity slot.}
    \item{spec \code{signature(object="rowROC")}}{Accessor method for
      specificity slot.}
    \item{area \code{signature(object="rowROC", total="logical")}}{Accessor method for
       pAUC slot.}
  }
}
\references{Pepe MS, Longton G, Anderson GL,
Schummer M.: Selecting
differentially expressed genes from microarray
experiments. \emph{Biometrics. 2003 Mar;59(1):133-42.}}
\author{Florian Hahne <fhahne@fhcrc.org>}


\seealso{
  \code{\link[genefilter:rowpAUCs]{rowpAUCs}}
}
\examples{
library("Biobase")
data("sample.ExpressionSet")
roc <- rowpAUCs(sample.ExpressionSet, "sex", p=0.5)
roc
area(roc[1:3])

if(interactive()) {
par(ask=TRUE)
plot(roc)
plot(1-spec(roc[1]), sens(roc[2]))
par(ask=FALSE)
}

pAUC(roc, 0.1)
roc
}
\keyword{classes}

\name{half.range.mode}
\alias{half.range.mode}
\title{Mode estimation for continuous data}

\description{
  For data assumed to be drawn from a unimodal, continuous distribution,
  the mode is estimated by the \dQuote{half-range} method. Bootstrap resampling
  for variance reduction may optionally be used.
}

\usage{
half.range.mode(data, B, B.sample, beta = 0.5, diag = FALSE)
}

\arguments{
  \item{data}{A numeric vector of data from which to estimate the mode.}
  \item{B}{
    Optionally, the number of bootstrap resampling rounds to use. Note
    that \code{B = 1} resamples 1 time, whereas omitting \code{B}
    uses \code{data} as is, without resampling.
  }
  \item{B.sample}{
    If bootstrap resampling is requested, the size of the bootstrap
    samples drawn from \code{data}. Default is to use a sample which is
    the same size as \code{data}. For large data sets, this may be slow
    and unnecessary.
  }
  \item{beta}{
    The fraction of the remaining range to use at each iteration.
  }
  \item{diag}{
    Print extensive diagnostics. For internal testing only... best left
    \code{FALSE}.
  }
}

\details{
  Briefly, the mode estimator is computed by iteratively identifying
  densest half ranges. (Other fractions of the current range can be
  requested by setting \code{beta} to something other than 0.5.) A densest half
  range is an interval whose width equals half the current range, and
  which contains the maximal number of observations. The subset of
  observations falling in the selected densest half range is then used to compute
  a new range, and the procedure is iterated. See the references for
  details.

  If bootstrapping is requested, \code{B} half-range mode estimates are
  computed for \code{B} bootstrap samples, and their average is returned
  as the final estimate.
}

\value{
  The mode estimate.
}

\references{
  \itemize{
    \item DR Bickel, \dQuote{Robust estimators of the mode and skewness of
    continuous data.} \emph{Computational Statistics & Data Analysis}
    39:153-163 (2002).

    \item SB Hedges and P Shah, \dQuote{Comparison of
    mode estimation methods and application in molecular clock analysis.} \emph{BMC
    Bioinformatics} 4:31-41 (2003).
  }
}

\author{Richard Bourgon <bourgon@stat.berkeley.edu>}
\seealso{\code{\link{shorth}}}
\keyword{univar}
\keyword{robust}

\examples{
## A single normal-mixture data set

x <- c( rnorm(10000), rnorm(2000, mean = 3) )
M <- half.range.mode( x )
M.bs <- half.range.mode( x, B = 100 )

if(interactive()){
hist( x, breaks = 40 )
abline( v = c( M, M.bs ), col = "red", lty = 1:2 )
legend(
       1.5, par("usr")[4],
       c( "Half-range mode", "With bootstrapping (B = 100)" ),
       lwd = 1, lty = 1:2, cex = .8, col = "red"
       )
}

# Sampling distribution, with and without bootstrapping

X <- rbind(
           matrix( rnorm(1000 * 100), ncol = 100 ),
           matrix( rnorm(200 * 100, mean = 3), ncol = 100 )
           )
M.list <- list(
               Simple = apply( X, 2, half.range.mode ),
               BS = apply( X, 2, half.range.mode, B = 100 )
               )

if(interactive()){
boxplot( M.list, main = "Effect of bootstrapping" )
abline( h = 0, col = "red" )
}
}

\name{ttest}
\alias{ttest}
\title{A filter function for a t.test }
\description{
  \code{ttest} returns a function of one argument with bindings for
  \code{cov} and \code{p}.
  The function, when evaluated, performs a t-test using \code{cov} as
  the covariate. It returns \code{TRUE} if the p value for a difference
  in means is less than \code{p}. 
}
\usage{
ttest(m, p=0.05, na.rm=TRUE)
}
\arguments{
  \item{m}{If \code{m} is of length one then it is assumed that elements
  one through \code{m} of \code{x} will be one group. Otherwise \code{m}
  is presumed to be the same length as \code{x} and constitutes the
  groups.}
  \item{p}{ The p-value for the test. }
  \item{na.rm}{If set to \code{TRUE} any \code{NA}'s will be removed. }
}
\details{
   When the data can be split into two groups (diseased and normal for
   example) then we often want to select genes on their ability to
   distinguish those two groups. The t-test is well suited to this and
   can be used as a filter function.

   This helper function creates a t-test (function) for the specified
   covariate and considers a gene to have passed the filter if the
   p-value for the gene is less than the prespecified \code{p}.
  }
\value{
 \code{ttest} returns a function with bindings for \code{m} and
 \code{p} that will perform a t-test.
}
\author{R. Gentleman }
\seealso{\code{\link{kOverA}}, \code{\link{Anova}}, \code{\link{t.test}} }

\examples{
  dat <- c(rep(1,5),rep(2,5))
  set.seed(5)
  y <- rnorm(10)
  af <- ttest(dat, .01)
  af(y)
  af2 <- ttest(5, .01)
  af2(y)
  y[8] <- NA
  af(y)
  af2(y)
  y[1:5] <- y[1:5]+10
  af(y)
}
\keyword{manip}

\name{Anova}
\alias{Anova}
\title{A filter function for Analysis of Variance }
\description{
  \code{Anova} returns a function of one argument with bindings for
  \code{cov} and \code{p}.
  The function, when evaluated, performs an ANOVA using \code{cov} as
  the covariate. It returns \code{TRUE} if the p value for a difference
  in means is less than \code{p}. 
}
\usage{
Anova(cov, p=0.05, na.rm=TRUE)
}
\arguments{
  \item{cov}{The covariate. It must have length equal to the number of
    columns of the array that \code{Anova} will be applied to. }
  \item{p}{ The p-value for the test. }
  \item{na.rm}{If set to \code{TRUE} any \code{NA}'s will be removed. }
}

\details{
  The function returned by \code{Anova} uses \code{lm} to fit a linear
  model of the form
  \code{lm(x ~ cov)}, where \code{x} is the set of gene expressions.
  The F statistic for an overall effect is computed and if it has a
  \emph{p}-value less than \code{p} the function returns \code{TRUE},
  otherwise it returns \code{FALSE} for that gene.
  }
\value{
 \code{Anova} returns a function with bindings for \code{cov} and
 \code{p} that will perform a one-way ANOVA.

  The covariate can be continuous, in which case the test is for a linear 
  effect for the covariate.
}
\author{R. Gentleman }
\seealso{\code{\link{kOverA}}, \code{\link{lm}} }

\examples{
  set.seed(123)
  af <- Anova(c(rep(1,5),rep(2,5)), .01)
  af(rnorm(10))
}
\keyword{manip}

\name{genefinder}
\alias{genefinder}
\alias{genefinder,ExpressionSet,vector-method}
\alias{genefinder,matrix,vector-method}
\title{Finds genes that have similar patterns of expression.}
\description{
  Given an \code{ExpressionSet} or a \code{matrix} of gene expressions, and the
  indices of the genes of interest, \code{genefinder} returns a \code{list} of the
  \code{numResults} closest genes.
  The user can specify one of the standard distance measures listed
  below.
  The number of values to return can be specified. The return value is a
  \code{list} with two components:
  genes (measured through the desired distance method) to the genes
  of interest (where X is the number of desired results returned) and
  their distances.
}
\usage{
genefinder(X, ilist, numResults=25, scale="none", weights, method="euclidean")
}
\arguments{
  \item{X}{A numeric \code{matrix} where columns represent patients and rows
    represent genes.}
  \item{ilist}{A \code{vector} of genes of interest. Contains indices of genes
    in matrix X.}
  \item{numResults}{Number of results to display, starting from the least
    distance to the greatest.}
  \item{scale}{One of "none", "range", or "zscore". Scaling
    is carried out separately on each row.}
  \item{weights}{A vector of weights applied across the columns of
    \code{X}. If no weights are supplied, no weights are applied.}
  \item{method}{One of "euclidean", "maximum", "manhattan", "canberra", 
        "correlation", "binary".}
}
\details{
  If the \code{scale} option is "range", then the input matrix is scaled using
  \code{genescale()}. If it is "zscore", then the input matrix is scaled using
  the \code{scale} builtin with no arguments.

  The method option specifies the metric used for gene comparisons. The
  metric is applied, row by row, for each gene specified in \code{ilist}.

  The "correlation" option for the distance method will return a value
  equal to 1-correlation(x).

  See \code{\link{dist}} for a more detailed description of the distances.
}
\value{
  The returned value is a \code{list} containing an entry for each gene
  specified in \code{ilist}. Each \code{list} entry contains an array of
  distances for that gene of interest.
}
\author{J. Gentry and M. Kajen}
\seealso{\code{\link{genescale}}}
\examples{
set.seed(12345)

#create some fake expression profiles
m1 <- matrix (1:12, 4, 3)
v1 <- 1
nr <- 2

#find the 2 rows of m1 that are closest to row 1
genefinder (m1, v1, nr, method="euc")

v2 <- c(1,3)
genefinder (m1, v2, nr)

genefinder (m1, v2, nr, scale="range")

genefinder (m1, v2, nr, method="manhattan")

m2 <- matrix (rnorm(100), 10, 10)
v3 <- c(2, 5, 6, 8)
nr2 <- 6
genefinder (m2, v3, nr2, scale="zscore")

\testonly{
	m1 <- matrix(rnorm(1000),100,10)
	v1 <- c(3,5,8,42)
	nr2 <- 35
	genefinder(m1,v1,nr2,method="euclidean")
	genefinder(m1,v1,nr2,method="maximum")
	genefinder(m1,v1,nr2,method="canberra")
	genefinder(m1,v1,nr2,method="binary")
	genefinder(m1,v1,nr2,method="correlation")
	
	m2 <- matrix(rnorm(10000),1000,10)
	v1 <- c(1,100,563,872,921,3,52,95,235,333)
	nr <- 100
	genefinder(m2,v1,nr2,scale="zscore",method="euclidean")
	genefinder(m2,v1,nr2,scale="range",method="maximum")
	genefinder(m2,v1,nr2,scale="zscore",method="canberra")
	genefinder(m2,v1,nr2,scale="range",method="binary")
	genefinder(m2,v1,nr2,scale="zscore",method="correlation")
	}
}
\keyword{manip}

\name{filterfun}
\alias{filterfun}
\title{Creates a first FALSE exiting function from the list of
  filter functions it is given. }
\description{
  This function creates a function that takes a single argument. The
  filtering functions are bound in the environment of the returned
  function and are applied sequentially to the argument of the returned
  function. When the first filter function evaluates to \code{FALSE} the
  function returns \code{FALSE} otherwise it returns \code{TRUE}.
}
\usage{
filterfun(...)
}
\arguments{
  \item{...}{Filtering functions. }
}

\value{
 \code{filterfun} returns a function that takes a single argument. It
 binds the filter functions given to it in the environment of the
 returned function. These functions are applied sequentially (in the
 order they were given to \code{filterfun}). The function returns
 \code{FALSE} (and exits) when the first filter function returns
 \code{FALSE} otherwise it returns \code{TRUE}.
}
\author{R. Gentleman }
\seealso{\code{\link{genefilter}} }
\examples{
 set.seed(333)
 x <- matrix(rnorm(100,2,1),nc=10)
 cvfun <- cv(.5,2.5)
 ffun <- filterfun(cvfun)
 which <- genefilter(x, ffun)
}
\keyword{manip}

\name{filter_volcano}

\Rdversion{1.1}

\alias{filter_volcano}

\title{Volcano plot for overall variance filtering}

\description{
  Generate a volcano plot contrasting p-value with fold change (on the
  log scale), in order to visualize the effect of filtering on overall
  variance and also assign significance via p-value.
}

\usage{
filter_volcano(
               d, p, S,
               n1, n2,
               alpha, S_cutoff,
               cex = 0.5, pch = 19,
               xlab = expression(paste(log[2], " fold change")),
               ylab = expression(paste("-", log[10], " p")),
               cols = c("grey80", "grey50", "black"),
               ltys = c(1, 3),
               use_legend = TRUE,
               ...
               )
}

\arguments{
  \item{d}{Fold changes, typically on the log scale, base 2.}
  
  \item{p}{The p-values}

  \item{S}{
    The overall standard deviation filter statistics, i.e., the
    square roots of the overall variance filter statistics.
  }

  \item{n1}{Sample size for group 1.}

  \item{n2}{Sample size for group 2.}
  
  \item{alpha}{Significance cutoff used for p-values.}
  
  \item{S_cutoff}{
    Filter cutoff used for the overall standard deviation in \code{S}.
  }
  
  \item{cex}{Point size for plotting.}

  \item{pch}{Point character for plotting.}
  
  \item{xlab}{Label for x-axis.}
  
  \item{ylab}{Label for y-axis.}
  
  \item{cols}{
    A vector of three colors used for plotting. These correspond to
    filtered data, data which pass the filter but are insignificant, and
    data pass the filter and are also statistically significant.
  }
  
  \item{ltys}{
    The induced bound on log-scale fold change is plotted, as is the
    significance cutoff for data passing the filter. The \code{ltys}
    argument gives line styles for these drawing these two thresholds on
    the plot.
  }

  \item{use_legend}{Should a legend for point color be produced?}

  \item{\dots}{Other arguments for \code{plot}.}
  
}

\author{Richard Bourgon <bourgon@ebi.ac.uk>}

\examples{
# See the vignette: Diagnostic plots for independent filtering
}

\name{dist2}
\alias{dist2}

\title{
  Calculate an n-by-n matrix by applying a function to
  all pairs of columns of an m-by-n matrix.
}
\description{
  Calculate an n-by-n matrix by applying a function to
  all pairs of columns of an m-by-n matrix.
}
\usage{
  dist2(x, fun, diagonal=0)
}

\arguments{
  \item{x}{A matrix.}
  \item{fun}{A symmetric function of two arguments that may be columns of \code{x}.}
  \item{diagonal}{The value to be used for the diagonal elements of the
    resulting matrix.}
}
\details{
  With the default value of \code{fun}, this function calculates
  for each pair of columns of \code{x} the mean of the absolute values
  of their differences (which is proportional to the L1-norm of their
  difference). This is a distance metric.

  The implementation assumes that
  \code{fun(x[,i], x[,j])} can be evaluated for all pairs of \code{i}
  and \code{j} (see examples), and that
  \code{fun} is symmetric, i.e.
  \code{fun(a, b) = fun(b, a)}.
  \code{fun(a, a)} is not actually evaluated, instead the value of \code{diagonal}
  is used to fill the diagonal elements of the returned matrix.

  Note that \code{\link[stats:dist]{dist}} computes distances between rows of
  \code{x}, while this function computes relations between columns of
  \code{x} (see examples).
}
\value{
  A symmetric matrix of size \code{n x n}.
}
\author{
  Wolfgang Huber, James Reid
}
\examples{

  # example matrix
  z = matrix(1:15693, ncol=3)
  matL1 = dist2(z)
  matL2 = dist2(z, fun=function(a,b) sqrt(sum((a-b)^2, na.rm=TRUE)))

  euc = as.matrix(dist(t(z)))

  stopifnot(identical(dim(matL2), dim(euc)),
            all(euc==matL2))

}
\keyword{manip}

\name{pOverA}
\alias{pOverA}

\title{A filter function to filter according to the proportion of
  elements larger than A. }
\description{
  A function that returns a function with values for \code{A}, \code{p}
  and \code{na.rm} bound to the specified values. The function takes a
  single vector, \code{x}, as an argument.
  When the returned function is evaluated it returns \code{TRUE} if the
  proportion of values in \code{x} that are larger than \code{A} is at
  least \code{p}. 
}
\usage{
pOverA(p=0.05, A=100, na.rm=TRUE)
}
\arguments{
  \item{A}{The value to be exceeded. }
  \item{p}{The proportion that need to exceed \code{A} for \code{TRUE}
    to be returned. }
  \item{na.rm}{ If \code{TRUE} then \code{NA}'s are removed. }
}

\value{
 \code{pOverA} returns a function with bindings for \code{A}, \code{p}
 and \code{na.rm}. This function evaluates to \code{TRUE} if the
  proportion of values in \code{x} that are larger than \code{A} exceeds
  \code{p}. 
}
\author{R. Gentleman}

\seealso{  \code{\link{cv}} }

\examples{
  ff<- pOverA(p=.1, 10)
  ff(1:20)
  ff(1:5)
}
\keyword{manip}

\name{rejection_plot}

\Rdversion{1.1}

\alias{rejection_plot}

\title{
  Plot rejections vs. p-value cutoff
}

\description{
  Plot the number, or fraction, of null hypotheses rejected as a
  function of the p-value cutoff. Multiple sets of p-values are
  accepted, in a list or in the columns of a matrix, in order to permit
  comparisons. 
}

\usage{
rejection_plot(p,
               col, lty = 1, lwd = 1,   
               xlab = "p cutoff", ylab = "number of rejections",
               xlim = c(0, 1), ylim,
               legend = names(p),
               at = c("all", "sample"),
               n_at = 100,
               probability = FALSE,
               ...
               )
}

\arguments{
  
  \item{p}{
    The p-values to be used for plotting. These may be in the columns of
    a matrix, or in the elements of a list. One curve will be generated
    for each column/element, and all \code{NA} entries will be
    dropped. If column or element names are supplied, they are used by
    default for a plot legend.
  }

  \item{col}{
    Colors to be used for each curve plotted. Recycled if necessary. If
    \code{col} is omitted, \code{\link{rainbow}} is used to generate a
    set of colors.
  }
  
  \item{lty}{
    Line styles to be used for each curve plotted. Recycled if necessary.
  }
  
  \item{lwd}{
    Line widths to be used for each curve plotted. Recycled if necessary.
  }
  
  \item{xlab}{
    X-axis text label.
  }
  
  \item{ylab}{
    Y-axis text label.
  }
  
  \item{xlim}{
    X-axis limits.
  }
  
  \item{ylim}{
    Y-axis limits.
  }
  
  \item{legend}{
    Text for legend. Matrix column names or list element names (see
    \code{p} above) are used by default. If \code{NULL}, no legend is
    plotted.
  }
  
  \item{at}{
    Should step functions be plotted with a step at every value in
    \code{p}, or should linear interpolation be used at a sample of
    points spanning \code{xlim}? The latter looks when there are many
    p-values.
  }
  
  \item{n_at}{
    When \code{at = "sample"} is given, how many sample points should be
    used for interpolation and plotting?
  }
  
  \item{probability}{
    Should the fraction of null hypotheses rejected be reported instead
    of the count? See the \code{probability} argument to
    \code{\link{hist}}. 
  }
  
  \item{\dots}{
    Other arguments to pass to the \code{\link{plot}} call which sets up
    the axes. Note that the \code{...} argument will not be passed to
    the \code{\link{lines}} calls which actually generate the curves.
  }
  
}

\value{
  A list of the step functions used for plotting is returned invisibly.
}

\author{Richard Bourgon <bourgon@ebi.ac.uk>}

\examples{
# See the vignette: Diagnostic plots for independent filtering
}

\name{rowpAUCs-methods}
\docType{methods}
\alias{rowpAUCs-methods}
\alias{rowpAUCs}
\alias{rowpAUCs,matrix,factor-method}
\alias{rowpAUCs,matrix,numeric-method}
\alias{rowpAUCs,ExpressionSet,ANY-method}
\alias{rowpAUCs,ExpressionSet,character-method}
\title{Rowwise ROC and pAUC computation}
\description{Methods for fast rowwise computation of ROC curves and
  (partial) area under the curve (pAUC) using the simple classification
  rule \code{x > theta}, where \code{theta} is a value in the range of
  \code{x}
}
\usage{
rowpAUCs(x, fac, p=0.1, flip=TRUE, caseNames=c("1", "2"))
}
\arguments{
  \item{x}{\code{ExpressionSet} or numeric \code{matrix}. The
    \code{matrix} must not contain \code{NA} values.}

  \item{fac}{A \code{factor} or \code{numeric} or \code{character} that can
    be coerced to a \code{factor}. If \code{x} is an \code{ExpressionSet},
    this may also be a character \code{vector} of length 1 with the name of
    a covariate variable in \code{x}. \code{fac} must have exactly 2 levels.
    For better control over the classification, use integer values in 0 and 1,
    where 1 indicates the "Disease" class in the sense of the Pepe et al paper
    (see below).}
 
  \item{p}{Numeric \code{vector} of length 1. Limit in (0,1) to integrate pAUC
    to.}
  
  \item{flip}{Logical. If \code{TRUE}, both classification rules \code{x
  > theta} and \code{x < theta} are tested and the (partial) area under
  the curve of the better one of the two is returned. This is
  appropriate for the cases in which the classification is not
  necessarily linked to higher expression values, but instead it is
  symmetric and one would assume both over- and under-expressed genes for
  both classes. You can set \code{flip} to \code{FALSE} if you only want
  to screen for genes which discriminate Disease from Control with the
  \code{x > theta} rule.}

  \item{caseNames}{The class names that are used when plotting the
    data. If \code{fac} is the name of the covariate variable in the
    \code{ExpressionSet} the function will use its levels as
    \code{caseNames}.}
}
\details{
  Rowwise calculation of Receiver Operating Characteristic (ROC) curves
  and the corresponding partial area under the curve (pAUC) for a given
  data matrix or \code{ExpressionSet}. The function is implemented in C
  and thus reasonably fast and memory efficient. Cutpoints (\code{theta}
  are calculated before the first, in between and after the last data
  value. By default, both classification rules \code{x > theta} and
  \code{x < theta} are tested and the (partial) area under the curve of
  the better one of the two is returned. This is only valid for
  symmetric cases, where the classification is independent of the
  magnitude of \code{x} (e.g., both over- and under-expression of
  different genes in the same class).  For unsymmetric cases in which
  you expect x to be consistently higher/lower in of of the two classes
  (e.g. presence or absence of a single biomarker) set \code{flip=FALSE}
  or use the functionality provided in the \code{ROC} package. For
  better control over the classification (i.e., the choice of "Disease"
  and "Control" class in the sense of the Pepe et al paper), argument
  \code{fac} can be an integer in \code{[0,1]} where 1 indicates
  "Disease" and 0 indicates "Control". 
}
\section{Methods}{
  \describe{
    Methods exist for \code{rowPAUCs}:
    \item{rowPAUCs}{\code{signature(x="matrix", fac="factor")}}
    \item{rowPAUCs}{\code{signature(x="matrix", fac="numeric")}}
    \item{rowPAUCs}{\code{signature(x="ExpressionSet")}}
    \item{rowPAUCs}{\code{signature(x="ExpressionSet", fac="character")}}
  }
}
\value{
  An object of class \code{\link[genefilter:rowROC-class]{rowROC}} with the
  calculated specificities and sensitivities for each row and the
  corresponding pAUCs and AUCs values. See
  \code{\link[genefilter:rowROC-class]{rowROC}} for details.
}
\references{Pepe MS, Longton G, Anderson GL,
Schummer M.: Selecting
    differentially expressed genes from microarray
    experiments. \emph{Biometrics. 2003 Mar;59(1):133-42.}} 
\author{Florian Hahne <fhahne@fhcrc.org>}
\seealso{\code{\link[ROC:rocdemo.sca]{rocdemo.sca},
    \link[ROC:AUC]{pAUC}, \link[genefilter:rowROC-class]{rowROC}}}
\examples{
library(Biobase)
data(sample.ExpressionSet)

r1 = rowttests(sample.ExpressionSet, "sex")
r2 = rowpAUCs(sample.ExpressionSet, "sex", p=0.1)

plot(area(r2, total=TRUE), r1$statistic, pch=16)
sel <- which(area(r2, total=TRUE) > 0.7)
plot(r2[sel])

## this compares performance and output of rowpAUCs to function pAUC in
## package ROC 
if(require(ROC)){
  ## performance
  myRule = function(x)
    pAUC(rocdemo.sca(truth = as.integer(sample.ExpressionSet$sex)-1 ,
         data = x, rule = dxrule.sca), t0 = 0.1)
  nGenes = 200
  cat("computation time for ", nGenes, "genes:\n")
  cat("function pAUC: ")
  print(system.time(r3 <- esApply(sample.ExpressionSet[1:nGenes, ], 1, myRule)))
  cat("function rowpAUCs: ")
  print(system.time(r2 <- rowpAUCs(sample.ExpressionSet[1:nGenes, ],
  "sex", p=1)))

  ## compare output
  myRule2 = function(x)
   pAUC(rocdemo.sca(truth = as.integer(sample.ExpressionSet$sex)-1 ,
                    data = x, rule = dxrule.sca), t0 = 1)
  r4 <-  esApply(sample.ExpressionSet[1:nGenes, ], 1, myRule2)
  plot(r4,area(r2), xlab="function pAUC", ylab="function rowpAUCs",
  main="pAUCs")

  plot(r4, area(rowpAUCs(sample.ExpressionSet[1:nGenes, ],
  "sex", p=1, flip=FALSE)), xlab="function pAUC", ylab="function rowpAUCs",
  main="pAUCs")

  r4[r4<0.5] <- 1-r4[r4<0.5]
  plot(r4, area(r2), xlab="function pAUC", ylab="function rowpAUCs",
  main="pAUCs")
 }
}
\keyword{math}

\name{gapFilter}
\alias{gapFilter}
\title{ A filter to select genes based on there being a gap. }
\description{
  The \code{gapFilter} looks for genes that might usefully discriminate
  between two groups (possibly unknown at the time of filtering).
  To do this we look for a gap in the ordered expression values. The gap
  must come in the central portion (we exclude jumps in the initial
  \code{Prop} values or the final \code{Prop} values).
  Alternatively, if the IQR for the gene is large that will also pass
  our test and the gene will be selected.
}
\usage{
gapFilter(Gap, IQR, Prop, na.rm=TRUE, neg.rm=TRUE)
}
\arguments{
  \item{Gap}{The size of the gap required to pass the test. }
  \item{IQR}{The size of the IQR required to pass the test. }
  \item{Prop}{The proportion (or number) of samples to exclude at either
  end.}
  \item{na.rm}{If \code{TRUE} then \code{NA}'s will be removed before
    processing. }
  \item{neg.rm}{ If \code{TRUE} then negative values in \code{x} will be
    removed before processing.}
}
\details{
  As stated above we are interested in 
}
\value{
 A function that returns either \code{TRUE} or \code{FALSE} depending on
 whether the vector supplied has a gap larger than \code{Gap} or an IQR
 (inter quartile range) larger than \code{IQR}. For computing the gap we
 want to exclude a proportion, \code{Prop} from either end of the sorted
 values. The reason for this requirement is that genes which differ in
 expression levels only for a few samples are not likely to be interesting.
}

\author{R. Gentleman }

\seealso{\code{\link{ttest}}, \code{\link{genefilter}} }

\examples{
 set.seed(256)
 x <- c(rnorm(10,100,3), rnorm(10, 100, 10))
 y <- x + c(rep(0,10), rep(100,10))
 tmp <- rbind(x,y) 
 Gfilter <- gapFilter(200, 100, 5)
 ffun <- filterfun(Gfilter)
 genefilter(tmp, ffun)
}
\keyword{manip}

\name{kappa_p}

\Rdversion{1.1}

\alias{kappa_p}
\alias{kappa_t}

\title{
  Compute proportionality constant for fold change bound.
}

\description{
  Filtering on overall variance induces a lower bound on fold
  change. This bound depends on the significance of the evidence against
  the null hypothesis, an is a multiple of the cutoff used for an
  overall variance filter. It also depends on sample size in both of the
  groups being compared. These functions compute the multiplier for the
  supplied p-values or t-statistics.
}

\usage{
kappa_p(p, n1, n2 = n1)
kappa_t(t, n1, n2 = n1)
}

\arguments{
  \item{p}{The p-values at which to compute the multiplier.}
  \item{t}{The t-statistics at which to compute the multiplier.}
  \item{n1}{Sample size for class 1.}
  \item{n2}{Sample size for class 2.}
}

\value{
  A vector of multipliers: one per p-value or t-static in
  \code{p} or \code{t}.
}

\author{Richard Bourgon <bourgon@ebi.ac.uk>}

\examples{
# See the vignette: Diagnostic plots for independent filtering
}

\name{filtered_p}

\Rdversion{1.1}

\alias{filtered_p}
\alias{filtered_R}

\title{
  Compute and adjust p-values, with filtering
}

\description{
  Given filter and test statistics in the form of unadjusted p-values,
  or functions able to compute these statistics from the data, filter
  and then correct the p-values across a range of filtering
  stringencies. 
}

\usage{
filtered_p(filter, test, theta, data, method = "none")
filtered_R(alpha, filter, test, theta, data, method = "none")
}

\arguments{

  \item{alpha}{
    A cutoff to which p-values, possibly adjusted for multiple testing,
    will be compared.
  }
  
  \item{filter}{
    A vector of stage-one filter statistics, or a function which is able
    to compute this vector from \code{data}, if \code{data} is supplied.
  }
  
  \item{test}{
    A vector of unadjusted p-values, or a function which is able
    to compute this vector from the filtered portion of \code{data}, if
    \code{data} is supplied. The option to supply a function is useful
    when the value of the test statistic depends on which hypotheses are
    filtered out at stage one. (The \pkg{limma} t-statistic is an
    example.) 
  }
  
  \item{theta}{
    A vector with one or more filtering fractions to consider. Actual
    cutoffs are then computed internally by applying
    \code{\link{quantile}} to the filter statistics contained in (or
    produced by) the \code{filter} argument.
  }
  
  \item{data}{
    If \code{filter} and/or \code{test} are functions rather than
    vectors of statistics, they will be applied to \code{data}. The
    functions will be passed the whole \code{data} object, and must work
    over rows, etc. themselves as appropriate.
  }
  
  \item{method}{
    The unadjusted p-values contained in (or produced by) \code{test}
    will be adjusted for multiple testing after filtering, using the
    \code{\link{p.adjust}} function in the \pkg{stats} package. See the
    \code{method} argument there for options.
  }p
  
}

\value{
  For \code{filtered_p}, a matrix of p-values, possible adjusted for
  multiple testing, with one row per null hypothesis and one column per
  filtering fraction given in \code{theta}. For a given column, entries
  which have been filtered out are \code{NA}.

  For \code{filtered_R}, a count of the entries in the \code{filtered_p}
  result which are less than \code{alpha}.
}

\author{Richard Bourgon <bourgon@ebi.ac.uk>}

\examples{
# See the vignette: Diagnostic plots for independent filtering
}

\seealso{
  See \code{\link{rejection_plot}} for visualization of
  \code{filtered_p} results.
}

\name{nsFilter}

\alias{nsFilter}
\alias{varFilter}
\alias{featureFilter}
\alias{nsFilter,ExpressionSet-method}

\title{Filtering of Features in an ExpressionSet}

\description{The function \code{nsFilter} tries to provide a one-stop shop for
  different options of filtering (removing) features from an ExpressionSet. 
  Filtering features exhibiting little variation, or a consistently low
  signal, across samples can be advantageous for
  the subsequent data analysis (Bourgon et al.).
  Furthermore, one may decide that there is little value in considering
  features with insufficient annotation.
}

\usage{
nsFilter(eset, require.entrez=TRUE,
    require.GOBP=FALSE, require.GOCC=FALSE,
    require.GOMF=FALSE, require.CytoBand=FALSE,
    remove.dupEntrez=TRUE, var.func=IQR,
    var.cutoff=0.5, var.filter=TRUE,
    filterByQuantile=TRUE, feature.exclude="^AFFX", ...)

varFilter(eset, var.func=IQR, var.cutoff=0.5, filterByQuantile=TRUE)

featureFilter(eset, require.entrez=TRUE,
    require.GOBP=FALSE, require.GOCC=FALSE,
    require.GOMF=FALSE, require.CytoBand=FALSE,
    remove.dupEntrez=TRUE, feature.exclude="^AFFX")
}

\arguments{
  \item{eset}{an \code{ExpressionSet} object}
  \item{var.func}{The function used as the per-feature filtering
    statistic. This function should return a numeric vector of length
    one when given a numeric vector as input.}
  \item{var.filter}{A logical indicating whether to perform
      filtering based on \code{var.func}.}  
  \item{filterByQuantile}{A logical indicating whether \code{var.cutoff}
    is to be interprested as a quantile of all \code{var.func} values
    (the default), or as an absolute value.}
  \item{var.cutoff}{A numeric value. If \code{var.filter} is TRUE,
    features whose value of \code{var.func} is less than either:
    the \code{var.cutoff}-quantile of all \code{var.func} values
    (if \code{filterByQuantile} is TRUE), or
    \code{var.cutoff} (if \code{filterByQuantile} is FALSE)
    will be removed.}
  \item{require.entrez}{If \code{TRUE}, filter out features
    without an Entrez Gene ID annotation. If using an annotation
    package where an identifier system other than Entrez Gene IDs is
    used as the central ID, then that ID will be required instead.}
  \item{require.GOBP, require.GOCC, require.GOMF}{If \code{TRUE}, filter out features
    whose target genes are not annotated to at least one GO term in
    the BP, CC or MF ontology, respectively.}
  \item{require.CytoBand}{If \code{TRUE}, filter out features
    whose target genes have no mapping to cytoband locations.} 
  \item{remove.dupEntrez}{If \code{TRUE} and there are features
      mapping to the same Entrez Gene ID (or equivalent), then the feature with
      the largest value of \code{var.func} will be retained and the
      other(s) removed.}
  \item{feature.exclude}{A character vector of regular expressions.
    Feature identifiers (i.e. value of \code{featureNames(eset)})
    that match one of the specified patterns will be filtered out.
    The default value is intended to filter out Affymetrix quality control
    probe sets.}
  \item{...}{Unused, but available for specializing methods.}
}
\details{
  In this Section, the effect of filtering on the type I error rate
  estimation / control of subsequent hypothesis testing is explained.
  See also the paper by Bourgon et al.
  
  \emph{Marginal type I errors}:
  Filtering on the basis of a statistic which is independent of the test
  statistic used for detecting differential gene expression can increase
  the detection rate at the same marginal type I error. This is
  clearly the case for filter criteria that do not depend on the data,
  such as the annotation based criteria provided by the \code{nsFilter}
  and \code{featureFilter} functions. However, marginal type I error can
  also be controlled for certain types of data-dependent criteria.
  Call \eqn{U^I}{U^1} the stage 1 filter statistic, which is a function
  that is applied feature by feature,
  based on whose value the feature is or is not accepted to
  pass to stage 2, and which depends only on the data for that feature
  and not any other feature, and call
  \eqn{U^{II}}{U^2} the stage 2 test statistic for differential expression.
  Sufficient conditions for marginal type-I error control are:
  \itemize{
    
    \item \eqn{U^I}{U^1} the overall (across all samples) variance or
    mean, 
    \eqn{U^{II}}{U^2} the t-statistic (or any other scale and location
    invariant statistic),
    data normal distributed and exchangeable across samples.

    \item \eqn{U^I}{U^1} the overall mean, 
    \eqn{U^{II}}{U^2} the moderated t-statistic
    (as in limma's \code{\link[limma:ebayes]{eBayes}} function),
    data normal distributed and exchangeable.
    
    \item \eqn{U^I}{U^1} a sample-class label independent function
    (e.g. overall mean, median, variance, IQR),
    \eqn{U^{II}}{U^2} the Wilcoxon rank sum statistic,
    data exchangeable.
  }

  \emph{Experiment-wide type I error}:
  Marginal type-I error control provided by the conditions above
  is sufficient for control of the family wise error rate (FWER).
  Note, however, that common false discovery rate (FDR) methods depend 
  not only on the marginal behaviour of the test statistics under the
  null hypothesis, but also on their joint distribution.
  The joint distribution can be affected by filtering,
  even when this filtering leaves the marginal distributions of 
  true-null test statistics unchanged. Filtering might, for example, 
  change correlation structure. The
  effect of this is negligible in many cases in practice, but this
  depends on the dataset and the filter used, and the assessment 
  is in the responsibility of the data analyst.
  
  \emph{Annotation Based Filtering} Arguments \code{require.entrez},
  \code{require.GOBP}, \code{require.GOCC}, \code{require.GOMF} and
  \code{require.CytoBand}
  filter based on available annotation data.  The annotation
  package is determined by calling \code{annotation(eset)}.

  \emph{Variance Based Filtering} The \code{var.filter},
  \code{var.func}, \code{var.cutoff} and \code{varByQuantile} arguments
  control numerical cutoff-based filtering.
  Probes for which \code{var.func} returns \code{NA} are
  removed.
  The default \code{var.func} is \code{IQR}, which we here define as
  \code{rowQ(eset, ceiling(0.75 * ncol(eset))) - rowQ(eset, floor(0.25 * ncol(eset)))};
  this choice is motivated by the observation that unexpressed genes are
  detected most reliably through low variability of their features
  across samples.
  Additionally, \code{IQR} is robust to outliers (see note below). The
  default \code{var.cutoff} is \code{0.5} and is motivated by a rule of
  thumb that in many tissues only 40\% of genes are expressed.
  Please adapt this value to your data and question.

  By default the numerical-filter cutoff is interpreted
  as a quantile, so with the default settings, 
  50\% of the genes are filtered. 

  Variance filtering is performed last, so that
  (if \code{varByQuantile=TRUE} and \code{remove.dupEntrez=TRUE}) the
  final number of genes does indeed exclude precisely the \code{var.cutoff} 
  fraction of unique genes remaining after all other filters were
  passed.
  
  The stand-alone function \code{varFilter} does only
  \code{var.func}-based filtering
  (and no annotation based filtering).
  \code{featureFilter} does only
  annotation based filtering and duplicate removal; it always
  performs duplicate removal to retain the highest-IQR
  probe for each gene.
}

\value{
  For \code{nsFilter} a list consisting of:
  \item{eset}{the filtered \code{ExpressionSet}}
  \item{filter.log}{a list giving details of how many probe sets where
    removed for each filtering step performed.}

  For both \code{varFilter} and \code{featureFilter} the filtered
  \code{ExpressionSet}.
}

\author{Seth Falcon (somewhat revised by Assaf Oron)}

\note{\code{IQR} is a reasonable variance-filter choice when the dataset
  is split into two roughly equal and relatively homogeneous phenotype
  groups. If your dataset has important groups smaller than 25\% of the
  overall sample size, or if you are interested in unusual
  individual-level patterns, then \code{IQR} may not be sensitive enough
  for your needs. In such cases, you should consider using less robust
  and more sensitive measures of variance (the simplest of which would
  be \code{sd}).}

\references{
  R. Bourgon, R. Gentleman, W. Huber,
  Independent filtering increases power for detecting differentially
  expressed genes, Technical Report.
}

\examples{
  library("hgu95av2.db")
  library("Biobase")
  data(sample.ExpressionSet)
  ans <- nsFilter(sample.ExpressionSet)
  ans$eset
  ans$filter.log

  ## skip variance-based filtering
  ans <- nsFilter(sample.ExpressionSet, var.filter=FALSE)

  a1 <- varFilter(sample.ExpressionSet)
  a2 <- featureFilter(sample.ExpressionSet)
}

\keyword{manip}

\name{genefilter}
\alias{genefilter}
\title{A function to filter genes.}
\description{
   \code{genefilter} filters genes in the array \code{expr} using the
   filter functions in \code{flist}. It returns an array of logical
   values (suitable for subscripting) of the same length as there are
   rows in \code{expr}. For each row of \code{expr} the returned value
   is \code{TRUE} if the row passed all the filter functions. Otherwise
   it is set to \code{FALSE}.
}
\usage{
genefilter(expr, flist)
}
\arguments{
  \item{expr}{A \code{matrix} or \code{ExpressionSet} that the
    filter functions will be applied to.}
  \item{flist}{A \code{list} of filter functions to apply to the array.}
}
\details{
   This package uses a very simple but powerful protocol for
   \emph{filtering} genes. The user simply constructs any number of
   tests that they want to apply. A test is simply a function (as
   constructed using one of the many helper functions in this package)
   that returns \code{TRUE} if the gene of interest passes the test (or
   filter) and \code{FALSE} if the gene of interest fails.

   The benefit of this approach is that each test is constructed
   individually (and can be tested individually). The tests are then
   applied sequentially to each gene. The function returns a logical
   vector indicating whether the gene passed all tests functions or
   failed at least one of them.

   Users can construct their own filters. These filters should accept
   a vector of values, corresponding to a row of the \code{expr} object.
   The user defined function should return a length 1 logical vector,
   with value \code{TRUE} or \code{FALSE}. User-defined functions can be 
   combined with \code{\link{filterfun}}, just as built-in filters.
}
\value{
  A logical \code{vector} of length equal to the number of rows of
  \code{expr}. The values in that \code{vector} indicate whether the
  corresponding row of \code{expr} passed the set of filter functions.
}
\author{R. Gentleman}
\seealso{\code{\link{genefilter}}, \code{\link{kOverA}}}
\examples{
   set.seed(-1)
   f1 <- kOverA(5, 10)
   flist <- filterfun(f1)
   exprA <- matrix(rnorm(1000, 10), ncol = 10)
   ans <- genefilter(exprA, flist)
}
\keyword{manip}

\name{eSetFilter}
\alias{eSetFilter}
\alias{getFilterNames}
\alias{getFuncDesc}
\alias{getRdAsText}
\alias{parseDesc}
\alias{parseArgs}
\alias{setESetArgs}
\alias{isESet}
\alias{showESet}
\title{A function to filter an eSet object}
\description{
  Given a Bioconductor's ExpressionSet object, this function filters
  genes using a set of selected filters.
}
\usage{
eSetFilter(eSet)
getFilterNames()
getFuncDesc(lib = "genefilter", funcs = getFilterNames())
getRdAsText(lib)
parseDesc(text)
parseArgs(text)
showESet(eSet)
setESetArgs(filter)
isESet(eSet)
}
\arguments{
  \item{eSet}{\code{eSet} an ExpressionSet object}
  \item{lib}{\code{lib} a character string for the name of an R library
    where functions of interests reside}
  \item{funcs}{\code{funcs} a vector of character strings for names of
    functions of interest}
  \item{text}{\code{text} a character of string from a filed
    (e. g. description, argument, ..) filed of an Rd file for a
    fucntion}
  \item{filter}{\code{filter} a character string for the name of a
  filter function} 
}
\details{
  These functions are deprecated. Please use the \sQuote{iSee} package instead.
  
  A set of filters may be selected to filter genes in through each of
  the filters in the order the filters have been selected
}
\value{
  A logical vector of length equal to the number of rows of 'expr'.
  The values in that vector indicate whether the corresponding row
  of 'expr' passed the set of filter functions.
}
\author{Jianhua Zhang}

\seealso{\code{\link{genefilter}}}
\examples{
 if( interactive() ) {
   data(sample.ExpressionSet)      
   res <- eSetFilter(sample.ExpressionSet)
 }
}
\keyword{manip}

\name{cv}
\alias{cv}
\title{A filter function for the coefficient of variation.}
\description{
  \code{cv} returns a function with values for \code{a} and \code{b}
  bound. This function takes a single argument. It computes the
  coefficient of variation for the input vector and returns \code{TRUE} if
  the coefficient of variation is between \code{a} and
  \code{b}. Otherwise it returns \code{FALSE}
}
\usage{
cv(a=1, b=Inf, na.rm=TRUE)
}
\arguments{
  \item{a}{The lower bound for the cv. }
  \item{b}{The upper bound for the cv. }
  \item{na.rm}{If set to \code{TRUE} any \code{NA}'s will be removed. }
}
\details{
  The coefficient of variation is the standard deviation divided by the 
  absolute value of the mean.
}
\value{
 It returns a function of one argument. The function has an environment
 with bindings for \code{a} and \code{b}.
}
\author{R. Gentleman }
\seealso{\code{\link{pOverA}}, \code{\link{kOverA}} }

\examples{
  set.seed(-3)
  cvfun <- cv(1,10)
  cvfun(rnorm(10,10))
  cvfun(rnorm(10))
}
\keyword{manip}

\name{findLargest}
\alias{findLargest}
\title{Find the Entrez Gene ID corresponding to the largest statistic}
\description{
  Most microarrays have multiple probes per gene (Entrez). This function
  finds all replicates, and then selects the one with the largest value
  of the test statistic.
}
\usage{
findLargest(gN, testStat, data = "hgu133plus2")
}

\arguments{
  \item{gN}{A vector of probe identifiers for the chip.}
  \item{testStat}{A vector of test statistics, of the same length as
    \code{gN} with the per probe test statistics.}
  \item{data}{The character string identifying the chip.}
}
\details{
  All the probe identifiers, \code{gN}, are mapped to Entrez Gene IDs
  and the duplicates determined.  For any set of probes that map to the
  same Gene ID, the one with the largest test statistic is found. The
  return vector is the named vector of selected probe identifiers. The
  names are the Entrez Gene IDs.

  This could be extended in different ways, such as allowing the user to
  use a different selection criterion.  Also, matching on different
  identifiers seems like another alternative.
}
\value{
 A named vector of probe IDs. The names are Entrez Gene IDs.
}

\author{R. Gentleman}

\seealso{\code{\link{sapply}}}
\examples{
  library("hgu95av2.db")
  set.seed(124)
  gN <- sample(ls(hgu95av2ENTREZID), 200)
  stats <- rnorm(200)
  findLargest(gN, stats, "hgu95av2")

}
\keyword{manip}

\name{genescale}
\alias{genescale}
\title{Scales a matrix or vector.}
\description{
  \code{genescale} returns a scaled version of the input matrix m by applying
  the following formula to each column of the matrix:
     \deqn{y[i] = ( x[i] - min(x) ) / ( max(x) - min(x) )}
}
\usage{
genescale(m, axis=2, method=c("Z", "R"), na.rm=TRUE)
}

\arguments{
  \item{m}{Input a matrix or a vector with numeric elements. }
  \item{axis}{An integer indicating which axis of \code{m} to scale.}
  \item{method}{Either "Z" or "R", indicating whether a Z scaling or a
    range scaling should be performed.}
  \item{na.rm}{A boolean indicating whether \code{NA}'s should be
    removed.}
}
\details{
  Either the rows or columns of \code{m} are scaled. This is done either
  by subtracting the mean and dividing by the standard deviation ("Z")
  or by subtracing the minimum and dividing by the range.
}
\value{
  A scaled version of the input.
  If \code{m} is a \code{matrix} or a \code{dataframe} then the
  dimensions of the returned value agree with that of \code{m},
  in both cases the returned value is a \code{matrix}.
}

\author{ R. Gentleman }

\seealso{ \code{\link{genefinder}},\code{\link{scale}} }

\examples{
  m <- matrix(1:12, 4, 3)
  genescale(m)
}
\keyword{ manip }

\name{shorth}
\alias{shorth}
\title{A location estimator based on the shorth}
\description{A location estimator based on the shorth}
\usage{shorth(x, na.rm=FALSE, tie.action="mean", tie.limit=0.05)}
\arguments{
  \item{x}{Numeric}
  \item{na.rm}{Logical. If \code{TRUE}, then non-finite (according to
    \code{\link{is.finite}}) values in \code{x} are ignored. Otherwise,
    presence of non-finite or \code{NA} values will lead to an error message.}
  \item{tie.action}{Character scalar. See details.}
  \item{tie.limit}{Numeric scalar. See details.}
}

\details{The shorth is the shortest interval that covers half of the
  values in \code{x}. This function calculates the mean of the \code{x}
  values that lie in the shorth. This was proposed by Andrews (1972) as a 
  robust estimator of location.

  Ties: if there are multiple shortest intervals,
  the action specified in \code{ties.action} is applied.
  Allowed values are \code{mean} (the default), \code{max} and \code{min}.
  For \code{mean}, the average value is considered; however, an error is
  generated if the start indices of the different shortest intervals
  differ by more than the fraction \code{tie.limit} of \code{length(x)}.
  For \code{min} and \code{max}, the left-most or right-most, respectively, of
  the multiple shortest intervals is considered.

  Rate of convergence: as an estimator of location of a unimodal
  distribution, under regularity conditions,
  the quantity computed here has an asymptotic rate of only \eqn{n^{-1/3}} and a
  complicated limiting distribution. 

  See \code{\link{half.range.mode}} for an iterative version
  that refines the estimate iteratively and has a builtin bootstrapping option.
}

\value{The mean of the \code{x} values that lie in the shorth.}

\references{
  \itemize{
    \item G Sawitzki, \dQuote{The Shorth Plot.}
    Available at http://lshorth.r-forge.r-project.org/TheShorthPlot.pdf 

    \item DF Andrews, \dQuote{Robust Estimates of Location.}
    Princeton University Press (1972).

    \item R Grueble, \dQuote{The Length of the Shorth.} Annals of
    Statistics 16, 2:619-628 (1988).

    \item DR Bickel and R Fruehwirth, \dQuote{On a fast, robust
    estimator of the mode: Comparisons to other robust estimators
    with applications.} Computational Statistics & Data Analysis
    50, 3500-3530 (2006).
  }
}

\author{Wolfgang Huber \url{http://www.ebi.ac.uk/huber}, Ligia Pedroso Bras}
\seealso{\code{\link{half.range.mode}}}

\examples{
 
  x = c(rnorm(500), runif(500) * 10)
  methods = c("mean", "median", "shorth", "half.range.mode")
  ests = sapply(methods, function(m) get(m)(x))

  if(interactive()) {
    colors = 1:4
    hist(x, 40, col="orange")
    abline(v=ests, col=colors, lwd=3, lty=1:2)
    legend(5, 100, names(ests), col=colors, lwd=3, lty=1:2) 
  }
}
\keyword{arith}

\name{rowFtests}
\alias{rowFtests}
\alias{rowFtests,matrix,factor-method}
\alias{rowFtests,ExpressionSet,factor-method}
\alias{rowFtests,ExpressionSet,character-method}

\alias{colFtests}
\alias{colFtests,matrix,factor-method}
\alias{colFtests,ExpressionSet,factor-method}
\alias{colFtests,ExpressionSet,character-method}

\alias{rowttests}
\alias{rowttests,matrix,factor-method}
\alias{rowttests,matrix,missing-method}
\alias{rowttests,ExpressionSet,factor-method}
\alias{rowttests,ExpressionSet,character-method}
\alias{rowttests,ExpressionSet,missing-method}

\alias{colttests}
\alias{colttests,matrix,factor-method}
\alias{colttests,matrix,missing-method}
\alias{colttests,ExpressionSet,factor-method}
\alias{colttests,ExpressionSet,character-method}
\alias{colttests,ExpressionSet,missing-method}

\alias{fastT}

\title{t-tests and F-tests for rows or columns of a matrix}
\description{t-tests and F-tests for rows or columns of a
  matrix, intended to be speed efficient.}
\usage{
rowttests(x, fac, tstatOnly = FALSE, na.rm = FALSE)
colttests(x, fac, tstatOnly = FALSE, na.rm = FALSE)
fastT(x, ig1, ig2, var.equal = TRUE)

rowFtests(x, fac, var.equal = TRUE)
colFtests(x, fac, var.equal = TRUE)
}
\arguments{
  \item{x}{Numeric matrix. The matrix must not contain \code{NA} values.
    For \code{rowttests} and \code{colttests}, \code{x} can also be an
    \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}.}

  \item{fac}{Factor which codes the grouping to be tested.
    There must be 1 or 2 groups for the t-tests (corresponding to one-
    and two-sample t-test), and 2 or more for the F-tests. If \code{fac}
    is missing, this is taken as a one-group test (i.e. is only allowed
    for the t-tests). The length
    of the factor needs to correspond to the sample size:
    for the \code{row*} functions, the length of the factor must be
    the same as the number of columns of \code{x},
    for the \code{col*} functions, it must be the same as the number
    of rows of \code{x}.

    If \code{x} is an
    \code{\link[Biobase:class.ExpressionSet]{ExpressionSet}}, then 
    \code{fac} may also be a character vector of length 1 with the
    name of a covariate in \code{x}.}

  \item{tstatOnly}{A logical variable indicating whether to calculate
    p-values from the t-distribution with appropriate degrees of
    freedom. If \code{TRUE}, just the t-statistics are
    returned. This can be considerably faster.}

  \item{na.rm}{A logical variable indicating whether to remove NA values
    prior to calculation test statistics.}

  \item{ig1}{The indices of the columns of \code{x} that correspond
    to group 1.}
  \item{ig2}{The indices of the columns of \code{x} that correspond
    to group 2.}

  \item{var.equal}{A logical variable indicating whether to treat the
    variances in the samples as equal.  If 'TRUE', a simple F test for
    the equality of means in a one-way analysis of variance is
    performed.  If 'FALSE', an approximate method of Welch (1951) is
    used, which generalizes the commonly known 2-sample Welch test to
    the case of arbitrarily many samples.}
}

\details{
  If \code{fac} is specified, \code{rowttests} performs for each
  row of \code{x} a two-sided, two-class t-test with equal variances.
  \code{fac} must be a factor of length \code{ncol(x)} with two levels,
  corresponding to the two groups. The sign of the resulting t-statistic
  corresponds to "group 1 minus group 2".
  If \code{fac} is missing, \code{rowttests} performs for each row of
  \code{x} a two-sided one-class t-test against the null hypothesis 'mean=0'.
  
  \code{rowttests} and \code{colttests} are implemented in C and
  should be reasonably fast and memory-efficient.
  \code{fastT} is an alternative implementation, in Fortran, possibly useful
  for certain legacy code.
  \code{rowFtests} and \code{colFtests} are currently implemented using
  matrix algebra in R. Compared to the \code{rowttests} and
  \code{colttests} functions,
  they are slower and use more memory.
}

\value{
  A \code{data.frame} with columns \code{statistic},
  \code{p.value} (optional in the case of the t-test functions) and
  \code{dm}, the difference of the group means (only in the
  case of the t-test functions).
  The \code{row.names} of the data.frame are taken from the
  corresponding dimension names of \code{x}.
  
  The degrees of freedom are provided in the attribute \code{df}.
  For the F-tests, if \code{var.equal} is 'FALSE', \code{nrow(x)+1}
  degree of freedoms 
  are given, the first one is the first degree of freedom (it is the
  same for each row) and the other ones are the second degree of freedom
  (one for each row). 
}
\references{B. L. Welch (1951), On the comparison of several mean values: an
     alternative approach. Biometrika, *38*, 330-336}
\author{Wolfgang Huber <whuber@embl.de>}
\seealso{\code{\link[multtest:mt.teststat]{mt.teststat}}}
\examples{
   ##
   ## example data
   ##
   x  = matrix(runif(40), nrow=4, ncol=10)
   f2 = factor(floor(runif(ncol(x))*2))
   f4 = factor(floor(runif(ncol(x))*4))

   ##
   ## one- and two group row t-test; 4-group F-test
   ##
   r1 = rowttests(x)
   r2 = rowttests(x, f2)
   r4 = rowFtests(x, f4)

   ## approximate equality
   about.equal = function(x,y,tol=1e-10)
     stopifnot(is.numeric(x), is.numeric(y), length(x)==length(y), all(abs(x-y) < tol))

   ##
   ## compare with the implementation in t.test
   ##
   for (j in 1:nrow(x)) {
     s1 = t.test(x[j,])
     about.equal(s1$statistic, r1$statistic[j])
     about.equal(s1$p.value,   r1$p.value[j])

     s2 = t.test(x[j,] ~ f2, var.equal=TRUE)
     about.equal(s2$statistic, r2$statistic[j])
     about.equal(s2$p.value,   r2$p.value[j])

     dm = -diff(tapply(x[j,], f2, mean))
     about.equal(dm, r2$dm[j])

     s4 = summary(lm(x[j,] ~ f4))
     about.equal(s4$fstatistic["value"], r4$statistic[j])
   }

   ##
   ## colttests
   ##
   c2 = colttests(t(x), f2)
   stopifnot(identical(r2, c2))

   ##
   ## missing values
   ##
   f2n = f2
   f2n[sample(length(f2n), 3)] = NA
   r2n = rowttests(x, f2n)
   for(j in 1:nrow(x)) {
     s2n = t.test(x[j,] ~ f2n, var.equal=TRUE)
     about.equal(s2n$statistic, r2n$statistic[j])
     about.equal(s2n$p.value,   r2n$p.value[j])
   }

   ##
   ## larger sample size
   ##
   x  = matrix(runif(1000000), nrow=4, ncol=250000)
   f2 = factor(floor(runif(ncol(x))*2))
   r2 = rowttests(x, f2) 
   for (j in 1:nrow(x)) {
     s2 = t.test(x[j,] ~ f2, var.equal=TRUE)
     about.equal(s2$statistic, r2$statistic[j])
     about.equal(s2$p.value,   r2$p.value[j])
   }

   ## single row matrix
   rowFtests(matrix(runif(10),1,10),as.factor(c(rep(1,5),rep(2,5))))
   rowttests(matrix(runif(10),1,10),as.factor(c(rep(1,5),rep(2,5))))
}
\keyword{math}

\name{genefilter-deprecated}
\alias{genefilter-deprecated}
\title{Deprecated functions in package \sQuote{genefilter}}

\description{
  These functions are provided for compatibility with older versions
  of \sQuote{genefilter} only, and will be defunct at the next release.
}

\details{
  The following functions are deprecated and will be made defunct; use
  the replacement indicated below:
  \itemize{
    \item{eSetFilter}
    \item{getFilterNames}
    \item{getFuncDesc}
    \item{getRdAsText}
    \item{parseDesc}
    \item{parseArgs}
    \item{showESet}
    \item{setESetArgs}
    \item{isESet}
  }
}

\name{rowSds}
\alias{rowSds}
\alias{rowVars}
\title{Row variance and standard deviation of a numeric array}
\description{
  Row  variance and standard deviation of a numeric array
}
\usage{
rowVars(x, ...)
rowSds(x, ...)
}
\arguments{
  \item{x}{An array of two or more dimensions, containing numeric,
          complex, integer or logical values, or a numeric data frame.}
  \item{...}{Further arguments that get passed on to
    \code{\link{rowMeans}} and \code{\link{rowSums}}.}
}

\value{
  A numeric or complex array of suitable size, or a vector if the
  result is one-dimensional.  The `dimnames' (or `names' for a
  vector result) are taken from the original array.
}
\details{These are very simple convenience functions, the main work is done in
  \code{\link{rowMeans}} and \code{\link{rowSums}}. See the function
  definition of \code{rowVars}, it is very simple.
}
\author{Wolfgang Huber \url{http://www.ebi.ac.uk/huber}}
\seealso{\code{\link{rowMeans}} and \code{\link{rowSums}}}

\examples{
   a = matrix(rnorm(1e4), nrow=10)
   rowSds(a)
}

\keyword{array}
\keyword{manip}

\name{maxA}
\alias{maxA}
\title{ A filter function to filter according to the maximum. }
\description{
  \code{maxA} returns a function with the parameter \code{A} bound.
  The returned function evaluates to \code{TRUE} if any element of its
  argument is larger than \code{A}.
}
\usage{
maxA(A=75, na.rm=TRUE)
}
\arguments{
  \item{A}{The value that at least one element must exceed. }
  \item{na.rm}{If \code{TRUE} then \code{NA}'s are removed. }
}

\value{
 \code{maxA} returns a function with an environment containing a binding
 for \code{A}.
 
}

\author{R. Gentleman }

\seealso{\code{\link{pOverA}} }

\examples{
   ff <- maxA(30)
   ff(1:10)
   ff(28:31)
}
\keyword{manip}
